(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('fs'), require('path')) :
	typeof define === 'function' && define.amd ? define(['exports', 'fs', 'path'], factory) :
	(factory((global.topside = {}),global.fs,global.path));
}(this, (function (exports,fs,path) { 'use strict';

	fs = fs && fs.hasOwnProperty('default') ? fs['default'] : fs;
	path = path && path.hasOwnProperty('default') ? path['default'] : path;

	var commonjsGlobal = typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

	function unwrapExports (x) {
		return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x.default : x;
	}

	function createCommonjsModule(fn, module) {
		return module = { exports: {} }, fn(module, module.exports), module.exports;
	}

	var CompilerInterface = createCommonjsModule(function (module, exports) {
	Object.defineProperty(exports, "__esModule", { value: true });
	var Context = /** @class */ (function () {
	    function Context() {
	    }
	    return Context;
	}());
	exports.Context = Context;
	var Fragment = /** @class */ (function () {
	    function Fragment(position) {
	        this.line = position.line;
	        this.ch = position.ch;
	        this.file = position.file;
	    }
	    return Fragment;
	}());
	exports.Fragment = Fragment;

	});

	unwrapExports(CompilerInterface);
	var CompilerInterface_1 = CompilerInterface.Context;
	var CompilerInterface_2 = CompilerInterface.Fragment;

	var CompileError_1 = createCommonjsModule(function (module, exports) {
	var __extends = (commonjsGlobal && commonjsGlobal.__extends) || (function () {
	    var extendStatics = function (d, b) {
	        extendStatics = Object.setPrototypeOf ||
	            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
	            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
	        return extendStatics(d, b);
	    };
	    return function (d, b) {
	        extendStatics(d, b);
	        function __() { this.constructor = d; }
	        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	    };
	})();
	Object.defineProperty(exports, "__esModule", { value: true });
	var CompileError = /** @class */ (function (_super) {
	    __extends(CompileError, _super);
	    function CompileError(message, line, ch) {
	        var _this = _super.call(this, message) || this;
	        _this.line = line;
	        _this.ch = ch;
	        _this.name = "CompileError";
	        return _this;
	    }
	    return CompileError;
	}(Error));
	exports.default = CompileError;

	});

	unwrapExports(CompileError_1);

	var Token_1 = createCommonjsModule(function (module, exports) {
	var __extends = (commonjsGlobal && commonjsGlobal.__extends) || (function () {
	    var extendStatics = function (d, b) {
	        extendStatics = Object.setPrototypeOf ||
	            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
	            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
	        return extendStatics(d, b);
	    };
	    return function (d, b) {
	        extendStatics(d, b);
	        function __() { this.constructor = d; }
	        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	    };
	})();
	Object.defineProperty(exports, "__esModule", { value: true });
	var Token = /** @class */ (function () {
	    function Token(type, data, line, ch, file, ruleName) {
	        this.type = type;
	        this.data = data;
	        this.line = line;
	        this.ch = ch;
	        this.file = file;
	        this.ruleName = ruleName;
	    }
	    return Token;
	}());
	exports.Token = Token;
	var TokenBuilder = /** @class */ (function () {
	    function TokenBuilder(line, ch, file) {
	        this.line = line;
	        this.ch = ch;
	        this.file = file;
	        this.data = [];
	        this.ruleName = [];
	    }
	    TokenBuilder.prototype.build = function () {
	        return new Token(this.type, this.data.join(''), this.line, this.ch, this.file, this.ruleName.join(''));
	    };
	    return TokenBuilder;
	}());
	exports.TokenBuilder = TokenBuilder;
	var TextToken = /** @class */ (function (_super) {
	    __extends(TextToken, _super);
	    function TextToken() {
	        var _this = _super !== null && _super.apply(this, arguments) || this;
	        _this.type = TextToken.type;
	        return _this;
	    }
	    TextToken.type = "TEXT";
	    return TextToken;
	}(TokenBuilder));
	exports.TextToken = TextToken;
	var AtRuleToken = /** @class */ (function (_super) {
	    __extends(AtRuleToken, _super);
	    function AtRuleToken() {
	        var _this = _super !== null && _super.apply(this, arguments) || this;
	        _this.type = AtRuleToken.type;
	        return _this;
	    }
	    AtRuleToken.type = "AT_RULE";
	    return AtRuleToken;
	}(TokenBuilder));
	exports.AtRuleToken = AtRuleToken;
	var InterpolationToken = /** @class */ (function (_super) {
	    __extends(InterpolationToken, _super);
	    function InterpolationToken() {
	        var _this = _super !== null && _super.apply(this, arguments) || this;
	        _this.type = InterpolationToken.type;
	        return _this;
	    }
	    InterpolationToken.type = "INTERPOLATION";
	    return InterpolationToken;
	}(TokenBuilder));
	exports.InterpolationToken = InterpolationToken;

	});

	unwrapExports(Token_1);
	var Token_2 = Token_1.Token;
	var Token_3 = Token_1.TokenBuilder;
	var Token_4 = Token_1.TextToken;
	var Token_5 = Token_1.AtRuleToken;
	var Token_6 = Token_1.InterpolationToken;

	var TextIterator_1 = createCommonjsModule(function (module, exports) {
	Object.defineProperty(exports, "__esModule", { value: true });
	var TextIterator = /** @class */ (function () {
	    function TextIterator() {
	        this.cursor = 0;
	        this.chunk = "";
	        this.line = 1;
	        this.ch = 1;
	        this.sliceBegin = 0;
	    }
	    TextIterator.prototype.feedChunk = function (chunk) {
	        if (this.hasNext()) {
	            throw new Error("A new chunk appeared before the previous one was finished");
	        }
	        this.cursor = 0;
	        this.chunk = chunk;
	    };
	    TextIterator.prototype.markSliceBegin = function () {
	        this.sliceBegin = this.cursor;
	    };
	    TextIterator.prototype.getSlice = function () {
	        return this.chunk.substring(this.sliceBegin, this.cursor);
	    };
	    TextIterator.prototype.nextChar = function () {
	        if (!this.hasNext()) {
	            throw new Error('Illegal state: iterator cannot move forward!');
	        }
	        this.cursor++;
	        this.ch++;
	        var c = this.chunk.charAt(this.cursor);
	        if (c === "\n") {
	            this.ch = 1;
	            this.line++;
	        }
	        return c;
	    };
	    TextIterator.prototype.currentChar = function () {
	        return this.chunk.charAt(this.cursor);
	    };
	    TextIterator.prototype.currentCharCode = function () {
	        return this.currentChar().charCodeAt(0);
	    };
	    TextIterator.prototype.nextCharCode = function () {
	        return this.nextChar().charCodeAt(0);
	    };
	    TextIterator.prototype.hasNext = function () {
	        return this.cursor < this.chunk.length;
	    };
	    TextIterator.prototype.getLine = function () {
	        return this.line;
	    };
	    TextIterator.prototype.getCh = function () {
	        return this.ch;
	    };
	    return TextIterator;
	}());
	exports.default = TextIterator;

	});

	unwrapExports(TextIterator_1);

	var Tokenizer_1 = createCommonjsModule(function (module, exports) {
	Object.defineProperty(exports, "__esModule", { value: true });



	var CHARCODE_a = "a".charCodeAt(0);
	var CHARCODE_z = "z".charCodeAt(0);
	var CHARCODE_OPEN_PAREN = "(".charCodeAt(0);
	var CHARCODE_SPACE = " ".charCodeAt(0);
	var CHARCODE_NL = "\n".charCodeAt(0);
	var CHARCODE_MINUS = "-".charCodeAt(0);
	var CHARCODE_UNDERSCORE = "_".charCodeAt(0);
	var Tokenizer = /** @class */ (function () {
	    function Tokenizer(file) {
	        this.file = file;
	        this.state = this.state_text;
	        this.it = new TextIterator_1.default();
	        this.charStack = [];
	        this.hasOpenParen = false;
	        this.ended = false;
	        this.tokens = [];
	        this.currentToken = new Token_1.TextToken(1, 1, file);
	    }
	    Tokenizer.prototype.consume = function (buf) {
	        this.assertNotEnded();
	        this.it.feedChunk(buf.replace(/\r/g, ""));
	        while (this.it.hasNext()) {
	            this.state(false);
	        }
	    };
	    Tokenizer.prototype.close = function () {
	        this.assertNotEnded();
	        this.ended = true;
	        this.state(true); // Send EOF to current state for parsing
	        this.tokens.push(this.currentToken.build());
	        return this.tokens;
	    };
	    Tokenizer.prototype.assertNotEnded = function () {
	        if (this.ended === true) {
	            throw new Error("Parser already closed");
	        }
	    };
	    Tokenizer.prototype.assertNotEOF = function (eof) {
	        if (eof) {
	            throw new CompileError_1.default("Unexpected end of file", this.it.getLine(), this.it.getCh());
	        }
	    };
	    Tokenizer.prototype.state_text = function (eof) {
	        if (eof)
	            return;
	        this.it.markSliceBegin();
	        var c = "";
	        for (c = this.it.currentChar(); this.it.hasNext(); c = this.it.nextChar()) {
	            if (c === '@') {
	                this.currentToken.data.push(this.it.getSlice());
	                this.state = this.state_atRuleBegin;
	                return;
	            }
	        }
	        this.currentToken.data.push(this.it.getSlice());
	    };
	    /**
	     * @@
	     *  ^
	     * Here
	     */
	    Tokenizer.prototype.state_atChar = function (eof) {
	        this.assertNotEOF(eof);
	        this.it.nextChar();
	        this.state = this.state_text;
	        this.currentToken.data.push('@');
	    };
	    /**
	     * @rule   (some data)
	     * ^
	     * Here
	     */
	    Tokenizer.prototype.state_atRuleBegin = function (eof) {
	        this.assertNotEOF(eof);
	        var c = this.it.nextChar();
	        if (c === '@') {
	            this.state = this.state_atChar;
	        }
	        else {
	            this.flushToken(new Token_1.AtRuleToken(this.it.getLine(), this.it.getCh() - 1, this.file));
	            this.state = this.state_atRuleName;
	        }
	    };
	    /**
	     * @rule   (some data)
	     *  ^^^^
	     *  Here
	     */
	    Tokenizer.prototype.state_atRuleName = function (eof) {
	        if (eof) {
	            // Rule with no parameter
	            return;
	        }
	        this.it.markSliceBegin();
	        var c = 0;
	        for (c = this.it.currentCharCode(); this.it.hasNext(); c = this.it.nextCharCode()) {
	            if ((c < CHARCODE_a || c > CHARCODE_z) && c !== CHARCODE_MINUS && c !== CHARCODE_UNDERSCORE) {
	                if (c !== CHARCODE_NL &&
	                    c !== CHARCODE_OPEN_PAREN &&
	                    c !== CHARCODE_SPACE) {
	                    throw new CompileError_1.default('Unexpected char: "' +
	                        String.fromCharCode(c) +
	                        '"\nexpected "[a-z_-]", "(", space or end of line', this.it.getLine(), this.it.getCh() - 1);
	                }
	                this.currentToken.ruleName.push(this.it.getSlice());
	                this.state = this.state_atRuleAwaitData;
	                return;
	            }
	        }
	        this.currentToken.ruleName.push(this.it.getSlice());
	    };
	    /**
	     * @rule   (some data)
	     *      ^^^
	     *     Here
	     */
	    Tokenizer.prototype.state_atRuleAwaitData = function (eof) {
	        if (eof) {
	            return;
	        }
	        var c = "";
	        for (c = this.it.currentChar(); this.it.hasNext(); c = this.it.nextChar()) {
	            switch (c) {
	                // Ignore spaces
	                case " ":
	                    break;
	                // Rule has no data. It ends now
	                case "\n":
	                    this.state = this.state_atRuleEnd;
	                    this.flushToken(new Token_1.TextToken(this.it.getLine(), this.it.getCh(), this.file));
	                    return;
	                // Rule has parenthesized data, it ends when the parenthesis is matched.
	                case "(":
	                    this.state = this.state_atRuleOpenParen;
	                    return;
	                // Rule has unparenthesized data, it ends when the line ends.
	                default:
	                    this.state = this.state_atRuleData;
	                    return;
	            }
	        }
	    };
	    /**
	     * @rule   (some() data)
	     *         ^
	     *        Here
	     */
	    Tokenizer.prototype.state_atRuleOpenParen = function (eof) {
	        this.assertNotEOF(eof);
	        this.hasOpenParen = true;
	        this.charStack.push("(");
	        this.it.nextChar();
	        this.state = this.state_atRuleData;
	    };
	    /**
	     * @rule   (some data)
	     *          ^^^^^^^^^
	     *             Here
	     */
	    Tokenizer.prototype.state_atRuleData = function (eof) {
	        this.assertNotEOF(eof);
	        this.it.markSliceBegin();
	        var c = "";
	        for (c = this.it.currentChar(); this.it.hasNext(); c = this.it.nextChar()) {
	            switch (c) {
	                case "(":
	                    if (this.hasOpenParen) {
	                        this.charStack.push(c);
	                    }
	                    break;
	                case ")":
	                    if (this.hasOpenParen) {
	                        var stacked = this.charStack.pop();
	                        if (stacked !== "(") {
	                            throw new CompileError_1.default("Unmatched parenthesis", this.it.getLine(), this.it.getCh());
	                        }
	                        if (this.charStack.length === 0) {
	                            this.currentToken.data.push(this.it.getSlice());
	                            this.flushToken(new Token_1.TextToken(this.it.getLine(), this.it.getCh(), this.file));
	                            this.state = this.state_atRuleEnd;
	                            this.hasOpenParen = false;
	                            return;
	                        }
	                    }
	                    break;
	                case "\n":
	                    if (!this.hasOpenParen) {
	                        this.currentToken.data.push(this.it.getSlice());
	                        this.flushToken(new Token_1.TextToken(this.it.getLine(), this.it.getCh(), this.file));
	                        this.state = this.state_atRuleEnd;
	                        return;
	                    }
	                    break;
	            }
	        }
	        this.currentToken.data.push(this.it.getSlice());
	    };
	    /**
	     * @rule   (some data)
	     *                   ^
	     *                 Here
	     *
	     * @simplerule
	     *            ^
	     *         or here
	     */
	    Tokenizer.prototype.state_atRuleEnd = function (eof) {
	        this.assertNotEOF(eof);
	        this.it.nextChar();
	        this.state = this.state_text;
	    };
	    Tokenizer.prototype.flushToken = function (nextToken) {
	        this.tokens.push(this.currentToken.build());
	        this.currentToken = nextToken;
	    };
	    return Tokenizer;
	}());
	exports.default = Tokenizer;

	});

	unwrapExports(Tokenizer_1);

	/* -*- Mode: js; js-indent-level: 2; -*- */
	/*
	 * Copyright 2011 Mozilla Foundation and contributors
	 * Licensed under the New BSD license. See LICENSE or:
	 * http://opensource.org/licenses/BSD-3-Clause
	 */

	const intToCharMap = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".split("");

	/**
	 * Encode an integer in the range of 0 to 63 to a single base 64 digit.
	 */
	var encode = function(number) {
	  if (0 <= number && number < intToCharMap.length) {
	    return intToCharMap[number];
	  }
	  throw new TypeError("Must be between 0 and 63: " + number);
	};

	var base64 = {
		encode: encode
	};

	/* -*- Mode: js; js-indent-level: 2; -*- */
	/*
	 * Copyright 2011 Mozilla Foundation and contributors
	 * Licensed under the New BSD license. See LICENSE or:
	 * http://opensource.org/licenses/BSD-3-Clause
	 *
	 * Based on the Base 64 VLQ implementation in Closure Compiler:
	 * https://code.google.com/p/closure-compiler/source/browse/trunk/src/com/google/debugging/sourcemap/Base64VLQ.java
	 *
	 * Copyright 2011 The Closure Compiler Authors. All rights reserved.
	 * Redistribution and use in source and binary forms, with or without
	 * modification, are permitted provided that the following conditions are
	 * met:
	 *
	 *  * Redistributions of source code must retain the above copyright
	 *    notice, this list of conditions and the following disclaimer.
	 *  * Redistributions in binary form must reproduce the above
	 *    copyright notice, this list of conditions and the following
	 *    disclaimer in the documentation and/or other materials provided
	 *    with the distribution.
	 *  * Neither the name of Google Inc. nor the names of its
	 *    contributors may be used to endorse or promote products derived
	 *    from this software without specific prior written permission.
	 *
	 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
	 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
	 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
	 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
	 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
	 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
	 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
	 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
	 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
	 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
	 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
	 */



	// A single base 64 digit can contain 6 bits of data. For the base 64 variable
	// length quantities we use in the source map spec, the first bit is the sign,
	// the next four bits are the actual value, and the 6th bit is the
	// continuation bit. The continuation bit tells us whether there are more
	// digits in this value following this digit.
	//
	//   Continuation
	//   |    Sign
	//   |    |
	//   V    V
	//   101011

	const VLQ_BASE_SHIFT = 5;

	// binary: 100000
	const VLQ_BASE = 1 << VLQ_BASE_SHIFT;

	// binary: 011111
	const VLQ_BASE_MASK = VLQ_BASE - 1;

	// binary: 100000
	const VLQ_CONTINUATION_BIT = VLQ_BASE;

	/**
	 * Converts from a two-complement value to a value where the sign bit is
	 * placed in the least significant bit.  For example, as decimals:
	 *   1 becomes 2 (10 binary), -1 becomes 3 (11 binary)
	 *   2 becomes 4 (100 binary), -2 becomes 5 (101 binary)
	 */
	function toVLQSigned(aValue) {
	  return aValue < 0
	    ? ((-aValue) << 1) + 1
	    : (aValue << 1) + 0;
	}

	/**
	 * Returns the base 64 VLQ encoded value.
	 */
	var encode$1 = function base64VLQ_encode(aValue) {
	  let encoded = "";
	  let digit;

	  let vlq = toVLQSigned(aValue);

	  do {
	    digit = vlq & VLQ_BASE_MASK;
	    vlq >>>= VLQ_BASE_SHIFT;
	    if (vlq > 0) {
	      // There are still more digits in this value, so we must make sure the
	      // continuation bit is marked.
	      digit |= VLQ_CONTINUATION_BIT;
	    }
	    encoded += base64.encode(digit);
	  } while (vlq > 0);

	  return encoded;
	};

	var base64Vlq = {
		encode: encode$1
	};

	var util = createCommonjsModule(function (module, exports) {
	/* -*- Mode: js; js-indent-level: 2; -*- */
	/*
	 * Copyright 2011 Mozilla Foundation and contributors
	 * Licensed under the New BSD license. See LICENSE or:
	 * http://opensource.org/licenses/BSD-3-Clause
	 */

	/**
	 * This is a helper function for getting values from parameter/options
	 * objects.
	 *
	 * @param args The object we are extracting values from
	 * @param name The name of the property we are getting.
	 * @param defaultValue An optional value to return if the property is missing
	 * from the object. If this is not specified and the property is missing, an
	 * error will be thrown.
	 */
	function getArg(aArgs, aName, aDefaultValue) {
	  if (aName in aArgs) {
	    return aArgs[aName];
	  } else if (arguments.length === 3) {
	    return aDefaultValue;
	  }
	    throw new Error('"' + aName + '" is a required argument.');

	}
	exports.getArg = getArg;

	const urlRegexp = /^(?:([\w+\-.]+):)?\/\/(?:(\w+:\w+)@)?([\w.-]*)(?::(\d+))?(.*)$/;
	const dataUrlRegexp = /^data:.+\,.+$/;

	function urlParse(aUrl) {
	  const match = aUrl.match(urlRegexp);
	  if (!match) {
	    return null;
	  }
	  return {
	    scheme: match[1],
	    auth: match[2],
	    host: match[3],
	    port: match[4],
	    path: match[5]
	  };
	}
	exports.urlParse = urlParse;

	function urlGenerate(aParsedUrl) {
	  let url = "";
	  if (aParsedUrl.scheme) {
	    url += aParsedUrl.scheme + ":";
	  }
	  url += "//";
	  if (aParsedUrl.auth) {
	    url += aParsedUrl.auth + "@";
	  }
	  if (aParsedUrl.host) {
	    url += aParsedUrl.host;
	  }
	  if (aParsedUrl.port) {
	    url += ":" + aParsedUrl.port;
	  }
	  if (aParsedUrl.path) {
	    url += aParsedUrl.path;
	  }
	  return url;
	}
	exports.urlGenerate = urlGenerate;

	const MAX_CACHED_INPUTS = 32;

	/**
	 * Takes some function `f(input) -> result` and returns a memoized version of
	 * `f`.
	 *
	 * We keep at most `MAX_CACHED_INPUTS` memoized results of `f` alive. The
	 * memoization is a dumb-simple, linear least-recently-used cache.
	 */
	function lruMemoize(f) {
	  const cache = [];

	  return function(input) {
	    for (let i = 0; i < cache.length; i++) {
	      if (cache[i].input === input) {
	        const temp = cache[0];
	        cache[0] = cache[i];
	        cache[i] = temp;
	        return cache[0].result;
	      }
	    }

	    const result = f(input);

	    cache.unshift({
	      input,
	      result,
	    });

	    if (cache.length > MAX_CACHED_INPUTS) {
	      cache.pop();
	    }

	    return result;
	  };
	}

	/**
	 * Normalizes a path, or the path portion of a URL:
	 *
	 * - Replaces consecutive slashes with one slash.
	 * - Removes unnecessary '.' parts.
	 * - Removes unnecessary '<dir>/..' parts.
	 *
	 * Based on code in the Node.js 'path' core module.
	 *
	 * @param aPath The path or url to normalize.
	 */
	const normalize = lruMemoize(function normalize(aPath) {
	  let path$$1 = aPath;
	  const url = urlParse(aPath);
	  if (url) {
	    if (!url.path) {
	      return aPath;
	    }
	    path$$1 = url.path;
	  }
	  const isAbsolute = exports.isAbsolute(path$$1);

	  // Split the path into parts between `/` characters. This is much faster than
	  // using `.split(/\/+/g)`.
	  const parts = [];
	  let start = 0;
	  let i = 0;
	  while (true) {
	    start = i;
	    i = path$$1.indexOf("/", start);
	    if (i === -1) {
	      parts.push(path$$1.slice(start));
	      break;
	    } else {
	      parts.push(path$$1.slice(start, i));
	      while (i < path$$1.length && path$$1[i] === "/") {
	        i++;
	      }
	    }
	  }

	  let up = 0;
	  for (i = parts.length - 1; i >= 0; i--) {
	    const part = parts[i];
	    if (part === ".") {
	      parts.splice(i, 1);
	    } else if (part === "..") {
	      up++;
	    } else if (up > 0) {
	      if (part === "") {
	        // The first part is blank if the path is absolute. Trying to go
	        // above the root is a no-op. Therefore we can remove all '..' parts
	        // directly after the root.
	        parts.splice(i + 1, up);
	        up = 0;
	      } else {
	        parts.splice(i, 2);
	        up--;
	      }
	    }
	  }
	  path$$1 = parts.join("/");

	  if (path$$1 === "") {
	    path$$1 = isAbsolute ? "/" : ".";
	  }

	  if (url) {
	    url.path = path$$1;
	    return urlGenerate(url);
	  }
	  return path$$1;
	});
	exports.normalize = normalize;

	/**
	 * Joins two paths/URLs.
	 *
	 * @param aRoot The root path or URL.
	 * @param aPath The path or URL to be joined with the root.
	 *
	 * - If aPath is a URL or a data URI, aPath is returned, unless aPath is a
	 *   scheme-relative URL: Then the scheme of aRoot, if any, is prepended
	 *   first.
	 * - Otherwise aPath is a path. If aRoot is a URL, then its path portion
	 *   is updated with the result and aRoot is returned. Otherwise the result
	 *   is returned.
	 *   - If aPath is absolute, the result is aPath.
	 *   - Otherwise the two paths are joined with a slash.
	 * - Joining for example 'http://' and 'www.example.com' is also supported.
	 */
	function join(aRoot, aPath) {
	  if (aRoot === "") {
	    aRoot = ".";
	  }
	  if (aPath === "") {
	    aPath = ".";
	  }
	  const aPathUrl = urlParse(aPath);
	  const aRootUrl = urlParse(aRoot);
	  if (aRootUrl) {
	    aRoot = aRootUrl.path || "/";
	  }

	  // `join(foo, '//www.example.org')`
	  if (aPathUrl && !aPathUrl.scheme) {
	    if (aRootUrl) {
	      aPathUrl.scheme = aRootUrl.scheme;
	    }
	    return urlGenerate(aPathUrl);
	  }

	  if (aPathUrl || aPath.match(dataUrlRegexp)) {
	    return aPath;
	  }

	  // `join('http://', 'www.example.com')`
	  if (aRootUrl && !aRootUrl.host && !aRootUrl.path) {
	    aRootUrl.host = aPath;
	    return urlGenerate(aRootUrl);
	  }

	  const joined = aPath.charAt(0) === "/"
	    ? aPath
	    : normalize(aRoot.replace(/\/+$/, "") + "/" + aPath);

	  if (aRootUrl) {
	    aRootUrl.path = joined;
	    return urlGenerate(aRootUrl);
	  }
	  return joined;
	}
	exports.join = join;

	exports.isAbsolute = function(aPath) {
	  return aPath.charAt(0) === "/" || urlRegexp.test(aPath);
	};

	/**
	 * Make a path relative to a URL or another path.
	 *
	 * @param aRoot The root path or URL.
	 * @param aPath The path or URL to be made relative to aRoot.
	 */
	function relative(aRoot, aPath) {
	  if (aRoot === "") {
	    aRoot = ".";
	  }

	  aRoot = aRoot.replace(/\/$/, "");

	  // It is possible for the path to be above the root. In this case, simply
	  // checking whether the root is a prefix of the path won't work. Instead, we
	  // need to remove components from the root one by one, until either we find
	  // a prefix that fits, or we run out of components to remove.
	  let level = 0;
	  while (aPath.indexOf(aRoot + "/") !== 0) {
	    const index = aRoot.lastIndexOf("/");
	    if (index < 0) {
	      return aPath;
	    }

	    // If the only part of the root that is left is the scheme (i.e. http://,
	    // file:///, etc.), one or more slashes (/), or simply nothing at all, we
	    // have exhausted all components, so the path is not relative to the root.
	    aRoot = aRoot.slice(0, index);
	    if (aRoot.match(/^([^\/]+:\/)?\/*$/)) {
	      return aPath;
	    }

	    ++level;
	  }

	  // Make sure we add a "../" for each component we removed from the root.
	  return Array(level + 1).join("../") + aPath.substr(aRoot.length + 1);
	}
	exports.relative = relative;

	const supportsNullProto = (function() {
	  const obj = Object.create(null);
	  return !("__proto__" in obj);
	}());

	function identity(s) {
	  return s;
	}

	/**
	 * Because behavior goes wacky when you set `__proto__` on objects, we
	 * have to prefix all the strings in our set with an arbitrary character.
	 *
	 * See https://github.com/mozilla/source-map/pull/31 and
	 * https://github.com/mozilla/source-map/issues/30
	 *
	 * @param String aStr
	 */
	function toSetString(aStr) {
	  if (isProtoString(aStr)) {
	    return "$" + aStr;
	  }

	  return aStr;
	}
	exports.toSetString = supportsNullProto ? identity : toSetString;

	function fromSetString(aStr) {
	  if (isProtoString(aStr)) {
	    return aStr.slice(1);
	  }

	  return aStr;
	}
	exports.fromSetString = supportsNullProto ? identity : fromSetString;

	function isProtoString(s) {
	  if (!s) {
	    return false;
	  }

	  const length = s.length;

	  if (length < 9 /* "__proto__".length */) {
	    return false;
	  }

	  /* eslint-disable no-multi-spaces */
	  if (s.charCodeAt(length - 1) !== 95  /* '_' */ ||
	      s.charCodeAt(length - 2) !== 95  /* '_' */ ||
	      s.charCodeAt(length - 3) !== 111 /* 'o' */ ||
	      s.charCodeAt(length - 4) !== 116 /* 't' */ ||
	      s.charCodeAt(length - 5) !== 111 /* 'o' */ ||
	      s.charCodeAt(length - 6) !== 114 /* 'r' */ ||
	      s.charCodeAt(length - 7) !== 112 /* 'p' */ ||
	      s.charCodeAt(length - 8) !== 95  /* '_' */ ||
	      s.charCodeAt(length - 9) !== 95  /* '_' */) {
	    return false;
	  }
	  /* eslint-enable no-multi-spaces */

	  for (let i = length - 10; i >= 0; i--) {
	    if (s.charCodeAt(i) !== 36 /* '$' */) {
	      return false;
	    }
	  }

	  return true;
	}

	/**
	 * Comparator between two mappings where the original positions are compared.
	 *
	 * Optionally pass in `true` as `onlyCompareGenerated` to consider two
	 * mappings with the same original source/line/column, but different generated
	 * line and column the same. Useful when searching for a mapping with a
	 * stubbed out mapping.
	 */
	function compareByOriginalPositions(mappingA, mappingB, onlyCompareOriginal) {
	  let cmp = strcmp(mappingA.source, mappingB.source);
	  if (cmp !== 0) {
	    return cmp;
	  }

	  cmp = mappingA.originalLine - mappingB.originalLine;
	  if (cmp !== 0) {
	    return cmp;
	  }

	  cmp = mappingA.originalColumn - mappingB.originalColumn;
	  if (cmp !== 0 || onlyCompareOriginal) {
	    return cmp;
	  }

	  cmp = mappingA.generatedColumn - mappingB.generatedColumn;
	  if (cmp !== 0) {
	    return cmp;
	  }

	  cmp = mappingA.generatedLine - mappingB.generatedLine;
	  if (cmp !== 0) {
	    return cmp;
	  }

	  return strcmp(mappingA.name, mappingB.name);
	}
	exports.compareByOriginalPositions = compareByOriginalPositions;

	/**
	 * Comparator between two mappings with deflated source and name indices where
	 * the generated positions are compared.
	 *
	 * Optionally pass in `true` as `onlyCompareGenerated` to consider two
	 * mappings with the same generated line and column, but different
	 * source/name/original line and column the same. Useful when searching for a
	 * mapping with a stubbed out mapping.
	 */
	function compareByGeneratedPositionsDeflated(mappingA, mappingB, onlyCompareGenerated) {
	  let cmp = mappingA.generatedLine - mappingB.generatedLine;
	  if (cmp !== 0) {
	    return cmp;
	  }

	  cmp = mappingA.generatedColumn - mappingB.generatedColumn;
	  if (cmp !== 0 || onlyCompareGenerated) {
	    return cmp;
	  }

	  cmp = strcmp(mappingA.source, mappingB.source);
	  if (cmp !== 0) {
	    return cmp;
	  }

	  cmp = mappingA.originalLine - mappingB.originalLine;
	  if (cmp !== 0) {
	    return cmp;
	  }

	  cmp = mappingA.originalColumn - mappingB.originalColumn;
	  if (cmp !== 0) {
	    return cmp;
	  }

	  return strcmp(mappingA.name, mappingB.name);
	}
	exports.compareByGeneratedPositionsDeflated = compareByGeneratedPositionsDeflated;

	function strcmp(aStr1, aStr2) {
	  if (aStr1 === aStr2) {
	    return 0;
	  }

	  if (aStr1 === null) {
	    return 1; // aStr2 !== null
	  }

	  if (aStr2 === null) {
	    return -1; // aStr1 !== null
	  }

	  if (aStr1 > aStr2) {
	    return 1;
	  }

	  return -1;
	}

	/**
	 * Comparator between two mappings with inflated source and name strings where
	 * the generated positions are compared.
	 */
	function compareByGeneratedPositionsInflated(mappingA, mappingB) {
	  let cmp = mappingA.generatedLine - mappingB.generatedLine;
	  if (cmp !== 0) {
	    return cmp;
	  }

	  cmp = mappingA.generatedColumn - mappingB.generatedColumn;
	  if (cmp !== 0) {
	    return cmp;
	  }

	  cmp = strcmp(mappingA.source, mappingB.source);
	  if (cmp !== 0) {
	    return cmp;
	  }

	  cmp = mappingA.originalLine - mappingB.originalLine;
	  if (cmp !== 0) {
	    return cmp;
	  }

	  cmp = mappingA.originalColumn - mappingB.originalColumn;
	  if (cmp !== 0) {
	    return cmp;
	  }

	  return strcmp(mappingA.name, mappingB.name);
	}
	exports.compareByGeneratedPositionsInflated = compareByGeneratedPositionsInflated;

	/**
	 * Strip any JSON XSSI avoidance prefix from the string (as documented
	 * in the source maps specification), and then parse the string as
	 * JSON.
	 */
	function parseSourceMapInput(str) {
	  return JSON.parse(str.replace(/^\)]}'[^\n]*\n/, ""));
	}
	exports.parseSourceMapInput = parseSourceMapInput;

	/**
	 * Compute the URL of a source given the the source root, the source's
	 * URL, and the source map's URL.
	 */
	function computeSourceURL(sourceRoot, sourceURL, sourceMapURL) {
	  sourceURL = sourceURL || "";

	  if (sourceRoot) {
	    // This follows what Chrome does.
	    if (sourceRoot[sourceRoot.length - 1] !== "/" && sourceURL[0] !== "/") {
	      sourceRoot += "/";
	    }
	    // The spec says:
	    //   Line 4: An optional source root, useful for relocating source
	    //   files on a server or removing repeated values in the
	    //   “sources” entry.  This value is prepended to the individual
	    //   entries in the “source” field.
	    sourceURL = sourceRoot + sourceURL;
	  }

	  // Historically, SourceMapConsumer did not take the sourceMapURL as
	  // a parameter.  This mode is still somewhat supported, which is why
	  // this code block is conditional.  However, it's preferable to pass
	  // the source map URL to SourceMapConsumer, so that this function
	  // can implement the source URL resolution algorithm as outlined in
	  // the spec.  This block is basically the equivalent of:
	  //    new URL(sourceURL, sourceMapURL).toString()
	  // ... except it avoids using URL, which wasn't available in the
	  // older releases of node still supported by this library.
	  //
	  // The spec says:
	  //   If the sources are not absolute URLs after prepending of the
	  //   “sourceRoot”, the sources are resolved relative to the
	  //   SourceMap (like resolving script src in a html document).
	  if (sourceMapURL) {
	    const parsed = urlParse(sourceMapURL);
	    if (!parsed) {
	      throw new Error("sourceMapURL could not be parsed");
	    }
	    if (parsed.path) {
	      // Strip the last path component, but keep the "/".
	      const index = parsed.path.lastIndexOf("/");
	      if (index >= 0) {
	        parsed.path = parsed.path.substring(0, index + 1);
	      }
	    }
	    sourceURL = join(urlGenerate(parsed), sourceURL);
	  }

	  return normalize(sourceURL);
	}
	exports.computeSourceURL = computeSourceURL;
	});
	var util_1 = util.getArg;
	var util_2 = util.urlParse;
	var util_3 = util.urlGenerate;
	var util_4 = util.normalize;
	var util_5 = util.join;
	var util_6 = util.isAbsolute;
	var util_7 = util.relative;
	var util_8 = util.toSetString;
	var util_9 = util.fromSetString;
	var util_10 = util.compareByOriginalPositions;
	var util_11 = util.compareByGeneratedPositionsDeflated;
	var util_12 = util.compareByGeneratedPositionsInflated;
	var util_13 = util.parseSourceMapInput;
	var util_14 = util.computeSourceURL;

	/* -*- Mode: js; js-indent-level: 2; -*- */
	/*
	 * Copyright 2011 Mozilla Foundation and contributors
	 * Licensed under the New BSD license. See LICENSE or:
	 * http://opensource.org/licenses/BSD-3-Clause
	 */

	/**
	 * A data structure which is a combination of an array and a set. Adding a new
	 * member is O(1), testing for membership is O(1), and finding the index of an
	 * element is O(1). Removing elements from the set is not supported. Only
	 * strings are supported for membership.
	 */
	class ArraySet {
	  constructor() {
	    this._array = [];
	    this._set = new Map();
	  }

	  /**
	   * Static method for creating ArraySet instances from an existing array.
	   */
	  static fromArray(aArray, aAllowDuplicates) {
	    const set = new ArraySet();
	    for (let i = 0, len = aArray.length; i < len; i++) {
	      set.add(aArray[i], aAllowDuplicates);
	    }
	    return set;
	  }

	  /**
	   * Return how many unique items are in this ArraySet. If duplicates have been
	   * added, than those do not count towards the size.
	   *
	   * @returns Number
	   */
	  size() {
	    return this._set.size;
	  }

	  /**
	   * Add the given string to this set.
	   *
	   * @param String aStr
	   */
	  add(aStr, aAllowDuplicates) {
	    const isDuplicate = this.has(aStr);
	    const idx = this._array.length;
	    if (!isDuplicate || aAllowDuplicates) {
	      this._array.push(aStr);
	    }
	    if (!isDuplicate) {
	      this._set.set(aStr, idx);
	    }
	  }

	  /**
	   * Is the given string a member of this set?
	   *
	   * @param String aStr
	   */
	  has(aStr) {
	      return this._set.has(aStr);
	  }

	  /**
	   * What is the index of the given string in the array?
	   *
	   * @param String aStr
	   */
	  indexOf(aStr) {
	    const idx = this._set.get(aStr);
	    if (idx >= 0) {
	        return idx;
	    }
	    throw new Error('"' + aStr + '" is not in the set.');
	  }

	  /**
	   * What is the element at the given index?
	   *
	   * @param Number aIdx
	   */
	  at(aIdx) {
	    if (aIdx >= 0 && aIdx < this._array.length) {
	      return this._array[aIdx];
	    }
	    throw new Error("No element indexed by " + aIdx);
	  }

	  /**
	   * Returns the array representation of this set (which has the proper indices
	   * indicated by indexOf). Note that this is a copy of the internal array used
	   * for storing the members so that no one can mess with internal state.
	   */
	  toArray() {
	    return this._array.slice();
	  }
	}
	var ArraySet_1 = ArraySet;

	var arraySet = {
		ArraySet: ArraySet_1
	};

	/* -*- Mode: js; js-indent-level: 2; -*- */
	/*
	 * Copyright 2014 Mozilla Foundation and contributors
	 * Licensed under the New BSD license. See LICENSE or:
	 * http://opensource.org/licenses/BSD-3-Clause
	 */



	/**
	 * Determine whether mappingB is after mappingA with respect to generated
	 * position.
	 */
	function generatedPositionAfter(mappingA, mappingB) {
	  // Optimized for most common case
	  const lineA = mappingA.generatedLine;
	  const lineB = mappingB.generatedLine;
	  const columnA = mappingA.generatedColumn;
	  const columnB = mappingB.generatedColumn;
	  return lineB > lineA || lineB == lineA && columnB >= columnA ||
	         util.compareByGeneratedPositionsInflated(mappingA, mappingB) <= 0;
	}

	/**
	 * A data structure to provide a sorted view of accumulated mappings in a
	 * performance conscious manner. It trades a negligible overhead in general
	 * case for a large speedup in case of mappings being added in order.
	 */
	class MappingList {
	  constructor() {
	    this._array = [];
	    this._sorted = true;
	    // Serves as infimum
	    this._last = {generatedLine: -1, generatedColumn: 0};
	  }

	  /**
	   * Iterate through internal items. This method takes the same arguments that
	   * `Array.prototype.forEach` takes.
	   *
	   * NOTE: The order of the mappings is NOT guaranteed.
	   */
	  unsortedForEach(aCallback, aThisArg) {
	    this._array.forEach(aCallback, aThisArg);
	  }

	  /**
	   * Add the given source mapping.
	   *
	   * @param Object aMapping
	   */
	  add(aMapping) {
	    if (generatedPositionAfter(this._last, aMapping)) {
	      this._last = aMapping;
	      this._array.push(aMapping);
	    } else {
	      this._sorted = false;
	      this._array.push(aMapping);
	    }
	  }

	  /**
	   * Returns the flat, sorted array of mappings. The mappings are sorted by
	   * generated position.
	   *
	   * WARNING: This method returns internal data without copying, for
	   * performance. The return value must NOT be mutated, and should be treated as
	   * an immutable borrow. If you want to take ownership, you must make your own
	   * copy.
	   */
	  toArray() {
	    if (!this._sorted) {
	      this._array.sort(util.compareByGeneratedPositionsInflated);
	      this._sorted = true;
	    }
	    return this._array;
	  }
	}

	var MappingList_1 = MappingList;

	var mappingList = {
		MappingList: MappingList_1
	};

	/* -*- Mode: js; js-indent-level: 2; -*- */
	/*
	 * Copyright 2011 Mozilla Foundation and contributors
	 * Licensed under the New BSD license. See LICENSE or:
	 * http://opensource.org/licenses/BSD-3-Clause
	 */



	const ArraySet$1 = arraySet.ArraySet;
	const MappingList$1 = mappingList.MappingList;

	/**
	 * An instance of the SourceMapGenerator represents a source map which is
	 * being built incrementally. You may pass an object with the following
	 * properties:
	 *
	 *   - file: The filename of the generated source.
	 *   - sourceRoot: A root for all relative URLs in this source map.
	 */
	class SourceMapGenerator {
	  constructor(aArgs) {
	    if (!aArgs) {
	      aArgs = {};
	    }
	    this._file = util.getArg(aArgs, "file", null);
	    this._sourceRoot = util.getArg(aArgs, "sourceRoot", null);
	    this._skipValidation = util.getArg(aArgs, "skipValidation", false);
	    this._sources = new ArraySet$1();
	    this._names = new ArraySet$1();
	    this._mappings = new MappingList$1();
	    this._sourcesContents = null;
	  }

	  /**
	   * Creates a new SourceMapGenerator based on a SourceMapConsumer
	   *
	   * @param aSourceMapConsumer The SourceMap.
	   */
	  static fromSourceMap(aSourceMapConsumer) {
	    const sourceRoot = aSourceMapConsumer.sourceRoot;
	    const generator = new SourceMapGenerator({
	      file: aSourceMapConsumer.file,
	      sourceRoot
	    });
	    aSourceMapConsumer.eachMapping(function(mapping) {
	      const newMapping = {
	        generated: {
	          line: mapping.generatedLine,
	          column: mapping.generatedColumn
	        }
	      };

	      if (mapping.source != null) {
	        newMapping.source = mapping.source;
	        if (sourceRoot != null) {
	          newMapping.source = util.relative(sourceRoot, newMapping.source);
	        }

	        newMapping.original = {
	          line: mapping.originalLine,
	          column: mapping.originalColumn
	        };

	        if (mapping.name != null) {
	          newMapping.name = mapping.name;
	        }
	      }

	      generator.addMapping(newMapping);
	    });
	    aSourceMapConsumer.sources.forEach(function(sourceFile) {
	      let sourceRelative = sourceFile;
	      if (sourceRoot !== null) {
	        sourceRelative = util.relative(sourceRoot, sourceFile);
	      }

	      if (!generator._sources.has(sourceRelative)) {
	        generator._sources.add(sourceRelative);
	      }

	      const content = aSourceMapConsumer.sourceContentFor(sourceFile);
	      if (content != null) {
	        generator.setSourceContent(sourceFile, content);
	      }
	    });
	    return generator;
	  }

	  /**
	   * Add a single mapping from original source line and column to the generated
	   * source's line and column for this source map being created. The mapping
	   * object should have the following properties:
	   *
	   *   - generated: An object with the generated line and column positions.
	   *   - original: An object with the original line and column positions.
	   *   - source: The original source file (relative to the sourceRoot).
	   *   - name: An optional original token name for this mapping.
	   */
	  addMapping(aArgs) {
	    const generated = util.getArg(aArgs, "generated");
	    const original = util.getArg(aArgs, "original", null);
	    let source = util.getArg(aArgs, "source", null);
	    let name = util.getArg(aArgs, "name", null);

	    if (!this._skipValidation) {
	      this._validateMapping(generated, original, source, name);
	    }

	    if (source != null) {
	      source = String(source);
	      if (!this._sources.has(source)) {
	        this._sources.add(source);
	      }
	    }

	    if (name != null) {
	      name = String(name);
	      if (!this._names.has(name)) {
	        this._names.add(name);
	      }
	    }

	    this._mappings.add({
	      generatedLine: generated.line,
	      generatedColumn: generated.column,
	      originalLine: original != null && original.line,
	      originalColumn: original != null && original.column,
	      source,
	      name
	    });
	  }

	  /**
	   * Set the source content for a source file.
	   */
	  setSourceContent(aSourceFile, aSourceContent) {
	    let source = aSourceFile;
	    if (this._sourceRoot != null) {
	      source = util.relative(this._sourceRoot, source);
	    }

	    if (aSourceContent != null) {
	      // Add the source content to the _sourcesContents map.
	      // Create a new _sourcesContents map if the property is null.
	      if (!this._sourcesContents) {
	        this._sourcesContents = Object.create(null);
	      }
	      this._sourcesContents[util.toSetString(source)] = aSourceContent;
	    } else if (this._sourcesContents) {
	      // Remove the source file from the _sourcesContents map.
	      // If the _sourcesContents map is empty, set the property to null.
	      delete this._sourcesContents[util.toSetString(source)];
	      if (Object.keys(this._sourcesContents).length === 0) {
	        this._sourcesContents = null;
	      }
	    }
	  }

	  /**
	   * Applies the mappings of a sub-source-map for a specific source file to the
	   * source map being generated. Each mapping to the supplied source file is
	   * rewritten using the supplied source map. Note: The resolution for the
	   * resulting mappings is the minimium of this map and the supplied map.
	   *
	   * @param aSourceMapConsumer The source map to be applied.
	   * @param aSourceFile Optional. The filename of the source file.
	   *        If omitted, SourceMapConsumer's file property will be used.
	   * @param aSourceMapPath Optional. The dirname of the path to the source map
	   *        to be applied. If relative, it is relative to the SourceMapConsumer.
	   *        This parameter is needed when the two source maps aren't in the same
	   *        directory, and the source map to be applied contains relative source
	   *        paths. If so, those relative source paths need to be rewritten
	   *        relative to the SourceMapGenerator.
	   */
	  applySourceMap(aSourceMapConsumer, aSourceFile, aSourceMapPath) {
	    let sourceFile = aSourceFile;
	    // If aSourceFile is omitted, we will use the file property of the SourceMap
	    if (aSourceFile == null) {
	      if (aSourceMapConsumer.file == null) {
	        throw new Error(
	          "SourceMapGenerator.prototype.applySourceMap requires either an explicit source file, " +
	          'or the source map\'s "file" property. Both were omitted.'
	        );
	      }
	      sourceFile = aSourceMapConsumer.file;
	    }
	    const sourceRoot = this._sourceRoot;
	    // Make "sourceFile" relative if an absolute Url is passed.
	    if (sourceRoot != null) {
	      sourceFile = util.relative(sourceRoot, sourceFile);
	    }
	    // Applying the SourceMap can add and remove items from the sources and
	    // the names array.
	    const newSources = this._mappings.toArray().length > 0
	      ? new ArraySet$1()
	      : this._sources;
	    const newNames = new ArraySet$1();

	    // Find mappings for the "sourceFile"
	    this._mappings.unsortedForEach(function(mapping) {
	      if (mapping.source === sourceFile && mapping.originalLine != null) {
	        // Check if it can be mapped by the source map, then update the mapping.
	        const original = aSourceMapConsumer.originalPositionFor({
	          line: mapping.originalLine,
	          column: mapping.originalColumn
	        });
	        if (original.source != null) {
	          // Copy mapping
	          mapping.source = original.source;
	          if (aSourceMapPath != null) {
	            mapping.source = util.join(aSourceMapPath, mapping.source);
	          }
	          if (sourceRoot != null) {
	            mapping.source = util.relative(sourceRoot, mapping.source);
	          }
	          mapping.originalLine = original.line;
	          mapping.originalColumn = original.column;
	          if (original.name != null) {
	            mapping.name = original.name;
	          }
	        }
	      }

	      const source = mapping.source;
	      if (source != null && !newSources.has(source)) {
	        newSources.add(source);
	      }

	      const name = mapping.name;
	      if (name != null && !newNames.has(name)) {
	        newNames.add(name);
	      }

	    }, this);
	    this._sources = newSources;
	    this._names = newNames;

	    // Copy sourcesContents of applied map.
	    aSourceMapConsumer.sources.forEach(function(srcFile) {
	      const content = aSourceMapConsumer.sourceContentFor(srcFile);
	      if (content != null) {
	        if (aSourceMapPath != null) {
	          srcFile = util.join(aSourceMapPath, srcFile);
	        }
	        if (sourceRoot != null) {
	          srcFile = util.relative(sourceRoot, srcFile);
	        }
	        this.setSourceContent(srcFile, content);
	      }
	    }, this);
	  }

	  /**
	   * A mapping can have one of the three levels of data:
	   *
	   *   1. Just the generated position.
	   *   2. The Generated position, original position, and original source.
	   *   3. Generated and original position, original source, as well as a name
	   *      token.
	   *
	   * To maintain consistency, we validate that any new mapping being added falls
	   * in to one of these categories.
	   */
	  _validateMapping(aGenerated, aOriginal, aSource, aName) {
	    // When aOriginal is truthy but has empty values for .line and .column,
	    // it is most likely a programmer error. In this case we throw a very
	    // specific error message to try to guide them the right way.
	    // For example: https://github.com/Polymer/polymer-bundler/pull/519
	    if (aOriginal && typeof aOriginal.line !== "number" && typeof aOriginal.column !== "number") {
	        throw new Error(
	            "original.line and original.column are not numbers -- you probably meant to omit " +
	            "the original mapping entirely and only map the generated position. If so, pass " +
	            "null for the original mapping instead of an object with empty or null values."
	        );
	    }

	    if (aGenerated && "line" in aGenerated && "column" in aGenerated
	        && aGenerated.line > 0 && aGenerated.column >= 0
	        && !aOriginal && !aSource && !aName) ; else if (aGenerated && "line" in aGenerated && "column" in aGenerated
	             && aOriginal && "line" in aOriginal && "column" in aOriginal
	             && aGenerated.line > 0 && aGenerated.column >= 0
	             && aOriginal.line > 0 && aOriginal.column >= 0
	             && aSource) ; else {
	      throw new Error("Invalid mapping: " + JSON.stringify({
	        generated: aGenerated,
	        source: aSource,
	        original: aOriginal,
	        name: aName
	      }));
	    }
	  }

	  /**
	   * Serialize the accumulated mappings in to the stream of base 64 VLQs
	   * specified by the source map format.
	   */
	  _serializeMappings() {
	    let previousGeneratedColumn = 0;
	    let previousGeneratedLine = 1;
	    let previousOriginalColumn = 0;
	    let previousOriginalLine = 0;
	    let previousName = 0;
	    let previousSource = 0;
	    let result = "";
	    let next;
	    let mapping;
	    let nameIdx;
	    let sourceIdx;

	    const mappings = this._mappings.toArray();
	    for (let i = 0, len = mappings.length; i < len; i++) {
	      mapping = mappings[i];
	      next = "";

	      if (mapping.generatedLine !== previousGeneratedLine) {
	        previousGeneratedColumn = 0;
	        while (mapping.generatedLine !== previousGeneratedLine) {
	          next += ";";
	          previousGeneratedLine++;
	        }
	      } else if (i > 0) {
	        if (!util.compareByGeneratedPositionsInflated(mapping, mappings[i - 1])) {
	          continue;
	        }
	        next += ",";
	      }

	      next += base64Vlq.encode(mapping.generatedColumn
	                                 - previousGeneratedColumn);
	      previousGeneratedColumn = mapping.generatedColumn;

	      if (mapping.source != null) {
	        sourceIdx = this._sources.indexOf(mapping.source);
	        next += base64Vlq.encode(sourceIdx - previousSource);
	        previousSource = sourceIdx;

	        // lines are stored 0-based in SourceMap spec version 3
	        next += base64Vlq.encode(mapping.originalLine - 1
	                                   - previousOriginalLine);
	        previousOriginalLine = mapping.originalLine - 1;

	        next += base64Vlq.encode(mapping.originalColumn
	                                   - previousOriginalColumn);
	        previousOriginalColumn = mapping.originalColumn;

	        if (mapping.name != null) {
	          nameIdx = this._names.indexOf(mapping.name);
	          next += base64Vlq.encode(nameIdx - previousName);
	          previousName = nameIdx;
	        }
	      }

	      result += next;
	    }

	    return result;
	  }

	  _generateSourcesContent(aSources, aSourceRoot) {
	    return aSources.map(function(source) {
	      if (!this._sourcesContents) {
	        return null;
	      }
	      if (aSourceRoot != null) {
	        source = util.relative(aSourceRoot, source);
	      }
	      const key = util.toSetString(source);
	      return Object.prototype.hasOwnProperty.call(this._sourcesContents, key)
	        ? this._sourcesContents[key]
	        : null;
	    }, this);
	  }

	  /**
	   * Externalize the source map.
	   */
	  toJSON() {
	    const map = {
	      version: this._version,
	      sources: this._sources.toArray(),
	      names: this._names.toArray(),
	      mappings: this._serializeMappings()
	    };
	    if (this._file != null) {
	      map.file = this._file;
	    }
	    if (this._sourceRoot != null) {
	      map.sourceRoot = this._sourceRoot;
	    }
	    if (this._sourcesContents) {
	      map.sourcesContent = this._generateSourcesContent(map.sources, map.sourceRoot);
	    }

	    return map;
	  }

	  /**
	   * Render the source map being generated to a string.
	   */
	  toString() {
	    return JSON.stringify(this.toJSON());
	  }
	}

	SourceMapGenerator.prototype._version = 3;
	var SourceMapGenerator_1 = SourceMapGenerator;

	var sourceMapGenerator = {
		SourceMapGenerator: SourceMapGenerator_1
	};

	var binarySearch = createCommonjsModule(function (module, exports) {
	/* -*- Mode: js; js-indent-level: 2; -*- */
	/*
	 * Copyright 2011 Mozilla Foundation and contributors
	 * Licensed under the New BSD license. See LICENSE or:
	 * http://opensource.org/licenses/BSD-3-Clause
	 */

	exports.GREATEST_LOWER_BOUND = 1;
	exports.LEAST_UPPER_BOUND = 2;

	/**
	 * Recursive implementation of binary search.
	 *
	 * @param aLow Indices here and lower do not contain the needle.
	 * @param aHigh Indices here and higher do not contain the needle.
	 * @param aNeedle The element being searched for.
	 * @param aHaystack The non-empty array being searched.
	 * @param aCompare Function which takes two elements and returns -1, 0, or 1.
	 * @param aBias Either 'binarySearch.GREATEST_LOWER_BOUND' or
	 *     'binarySearch.LEAST_UPPER_BOUND'. Specifies whether to return the
	 *     closest element that is smaller than or greater than the one we are
	 *     searching for, respectively, if the exact element cannot be found.
	 */
	function recursiveSearch(aLow, aHigh, aNeedle, aHaystack, aCompare, aBias) {
	  // This function terminates when one of the following is true:
	  //
	  //   1. We find the exact element we are looking for.
	  //
	  //   2. We did not find the exact element, but we can return the index of
	  //      the next-closest element.
	  //
	  //   3. We did not find the exact element, and there is no next-closest
	  //      element than the one we are searching for, so we return -1.
	  const mid = Math.floor((aHigh - aLow) / 2) + aLow;
	  const cmp = aCompare(aNeedle, aHaystack[mid], true);
	  if (cmp === 0) {
	    // Found the element we are looking for.
	    return mid;
	  } else if (cmp > 0) {
	    // Our needle is greater than aHaystack[mid].
	    if (aHigh - mid > 1) {
	      // The element is in the upper half.
	      return recursiveSearch(mid, aHigh, aNeedle, aHaystack, aCompare, aBias);
	    }

	    // The exact needle element was not found in this haystack. Determine if
	    // we are in termination case (3) or (2) and return the appropriate thing.
	    if (aBias == exports.LEAST_UPPER_BOUND) {
	      return aHigh < aHaystack.length ? aHigh : -1;
	    }
	    return mid;
	  }

	  // Our needle is less than aHaystack[mid].
	  if (mid - aLow > 1) {
	    // The element is in the lower half.
	    return recursiveSearch(aLow, mid, aNeedle, aHaystack, aCompare, aBias);
	  }

	  // we are in termination case (3) or (2) and return the appropriate thing.
	  if (aBias == exports.LEAST_UPPER_BOUND) {
	    return mid;
	  }
	  return aLow < 0 ? -1 : aLow;
	}

	/**
	 * This is an implementation of binary search which will always try and return
	 * the index of the closest element if there is no exact hit. This is because
	 * mappings between original and generated line/col pairs are single points,
	 * and there is an implicit region between each of them, so a miss just means
	 * that you aren't on the very start of a region.
	 *
	 * @param aNeedle The element you are looking for.
	 * @param aHaystack The array that is being searched.
	 * @param aCompare A function which takes the needle and an element in the
	 *     array and returns -1, 0, or 1 depending on whether the needle is less
	 *     than, equal to, or greater than the element, respectively.
	 * @param aBias Either 'binarySearch.GREATEST_LOWER_BOUND' or
	 *     'binarySearch.LEAST_UPPER_BOUND'. Specifies whether to return the
	 *     closest element that is smaller than or greater than the one we are
	 *     searching for, respectively, if the exact element cannot be found.
	 *     Defaults to 'binarySearch.GREATEST_LOWER_BOUND'.
	 */
	exports.search = function search(aNeedle, aHaystack, aCompare, aBias) {
	  if (aHaystack.length === 0) {
	    return -1;
	  }

	  let index = recursiveSearch(-1, aHaystack.length, aNeedle, aHaystack,
	                              aCompare, aBias || exports.GREATEST_LOWER_BOUND);
	  if (index < 0) {
	    return -1;
	  }

	  // We have found either the exact element, or the next-closest element than
	  // the one we are searching for. However, there may be more than one such
	  // element. Make sure we always return the smallest of these.
	  while (index - 1 >= 0) {
	    if (aCompare(aHaystack[index], aHaystack[index - 1], true) !== 0) {
	      break;
	    }
	    --index;
	  }

	  return index;
	};
	});
	var binarySearch_1 = binarySearch.GREATEST_LOWER_BOUND;
	var binarySearch_2 = binarySearch.LEAST_UPPER_BOUND;
	var binarySearch_3 = binarySearch.search;

	var readWasm = createCommonjsModule(function (module) {
	if (typeof fetch === "function") {
	  // Web version of reading a wasm file into an array buffer.

	  let mappingsWasmUrl = null;

	  module.exports = function readWasm() {
	    if (typeof mappingsWasmUrl !== "string") {
	      throw new Error("You must provide the URL of lib/mappings.wasm by calling " +
	                      "SourceMapConsumer.initialize({ 'lib/mappings.wasm': ... }) " +
	                      "before using SourceMapConsumer");
	    }

	    return fetch(mappingsWasmUrl)
	      .then(response => response.arrayBuffer());
	  };

	  module.exports.initialize = url => mappingsWasmUrl = url;
	} else {
	  // Node version of reading a wasm file into an array buffer.
	  const fs$$1 = fs;
	  const path$$1 = path;

	  module.exports = function readWasm() {
	    return new Promise((resolve, reject) => {
	      const wasmPath = path$$1.join(__dirname, "mappings.wasm");
	      fs$$1.readFile(wasmPath, null, (error, data) => {
	        if (error) {
	          reject(error);
	          return;
	        }

	        resolve(data.buffer);
	      });
	    });
	  };

	  module.exports.initialize = _ => {
	    console.debug("SourceMapConsumer.initialize is a no-op when running in node.js");
	  };
	}
	});
	var readWasm_1 = readWasm.initialize;

	/**
	 * Provide the JIT with a nice shape / hidden class.
	 */
	function Mapping() {
	  this.generatedLine = 0;
	  this.generatedColumn = 0;
	  this.lastGeneratedColumn = null;
	  this.source = null;
	  this.originalLine = null;
	  this.originalColumn = null;
	  this.name = null;
	}

	let cachedWasm = null;

	var wasm = function wasm() {
	  if (cachedWasm) {
	    return cachedWasm;
	  }

	  const callbackStack = [];

	  cachedWasm = readWasm().then(buffer => {
	      return WebAssembly.instantiate(buffer, {
	        env: {
	          mapping_callback(
	            generatedLine,
	            generatedColumn,

	            hasLastGeneratedColumn,
	            lastGeneratedColumn,

	            hasOriginal,
	            source,
	            originalLine,
	            originalColumn,

	            hasName,
	            name
	          ) {
	            const mapping = new Mapping();
	            // JS uses 1-based line numbers, wasm uses 0-based.
	            mapping.generatedLine = generatedLine + 1;
	            mapping.generatedColumn = generatedColumn;

	            if (hasLastGeneratedColumn) {
	              // JS uses inclusive last generated column, wasm uses exclusive.
	              mapping.lastGeneratedColumn = lastGeneratedColumn - 1;
	            }

	            if (hasOriginal) {
	              mapping.source = source;
	              // JS uses 1-based line numbers, wasm uses 0-based.
	              mapping.originalLine = originalLine + 1;
	              mapping.originalColumn = originalColumn;

	              if (hasName) {
	                mapping.name = name;
	              }
	            }

	            callbackStack[callbackStack.length - 1](mapping);
	          },

	          start_all_generated_locations_for() { console.time("all_generated_locations_for"); },
	          end_all_generated_locations_for() { console.timeEnd("all_generated_locations_for"); },

	          start_compute_column_spans() { console.time("compute_column_spans"); },
	          end_compute_column_spans() { console.timeEnd("compute_column_spans"); },

	          start_generated_location_for() { console.time("generated_location_for"); },
	          end_generated_location_for() { console.timeEnd("generated_location_for"); },

	          start_original_location_for() { console.time("original_location_for"); },
	          end_original_location_for() { console.timeEnd("original_location_for"); },

	          start_parse_mappings() { console.time("parse_mappings"); },
	          end_parse_mappings() { console.timeEnd("parse_mappings"); },

	          start_sort_by_generated_location() { console.time("sort_by_generated_location"); },
	          end_sort_by_generated_location() { console.timeEnd("sort_by_generated_location"); },

	          start_sort_by_original_location() { console.time("sort_by_original_location"); },
	          end_sort_by_original_location() { console.timeEnd("sort_by_original_location"); },
	        }
	      });
	  }).then(Wasm => {
	    return {
	      exports: Wasm.instance.exports,
	      withMappingCallback: (mappingCallback, f) => {
	        callbackStack.push(mappingCallback);
	        try {
	          f();
	        } finally {
	          callbackStack.pop();
	        }
	      }
	    };
	  }).then(null, e => {
	    cachedWasm = null;
	    throw e;
	  });

	  return cachedWasm;
	};

	/* -*- Mode: js; js-indent-level: 2; -*- */
	/*
	 * Copyright 2011 Mozilla Foundation and contributors
	 * Licensed under the New BSD license. See LICENSE or:
	 * http://opensource.org/licenses/BSD-3-Clause
	 */



	const ArraySet$2 = arraySet.ArraySet;
	 // eslint-disable-line no-unused-vars



	const INTERNAL = Symbol("smcInternal");

	class SourceMapConsumer {
	  constructor(aSourceMap, aSourceMapURL) {
	    // If the constructor was called by super(), just return Promise<this>.
	    // Yes, this is a hack to retain the pre-existing API of the base-class
	    // constructor also being an async factory function.
	    if (aSourceMap == INTERNAL) {
	      return Promise.resolve(this);
	    }

	    return _factory(aSourceMap, aSourceMapURL);
	  }

	  static initialize(opts) {
	    readWasm.initialize(opts["lib/mappings.wasm"]);
	  }

	  static fromSourceMap(aSourceMap, aSourceMapURL) {
	    return _factoryBSM(aSourceMap, aSourceMapURL);
	  }

	  /**
	   * Construct a new `SourceMapConsumer` from `rawSourceMap` and `sourceMapUrl`
	   * (see the `SourceMapConsumer` constructor for details. Then, invoke the `async
	   * function f(SourceMapConsumer) -> T` with the newly constructed consumer, wait
	   * for `f` to complete, call `destroy` on the consumer, and return `f`'s return
	   * value.
	   *
	   * You must not use the consumer after `f` completes!
	   *
	   * By using `with`, you do not have to remember to manually call `destroy` on
	   * the consumer, since it will be called automatically once `f` completes.
	   *
	   * ```js
	   * const xSquared = await SourceMapConsumer.with(
	   *   myRawSourceMap,
	   *   null,
	   *   async function (consumer) {
	   *     // Use `consumer` inside here and don't worry about remembering
	   *     // to call `destroy`.
	   *
	   *     const x = await whatever(consumer);
	   *     return x * x;
	   *   }
	   * );
	   *
	   * // You may not use that `consumer` anymore out here; it has
	   * // been destroyed. But you can use `xSquared`.
	   * console.log(xSquared);
	   * ```
	   */
	  static with(rawSourceMap, sourceMapUrl, f) {
	    // Note: The `acorn` version that `webpack` currently depends on doesn't
	    // support `async` functions, and the nodes that we support don't all have
	    // `.finally`. Therefore, this is written a bit more convolutedly than it
	    // should really be.

	    let consumer = null;
	    const promise = new SourceMapConsumer(rawSourceMap, sourceMapUrl);
	    return promise
	      .then(c => {
	        consumer = c;
	        return f(c);
	      })
	      .then(x => {
	        if (consumer) {
	          consumer.destroy();
	        }
	        return x;
	      }, e => {
	        if (consumer) {
	          consumer.destroy();
	        }
	        throw e;
	      });
	  }

	  /**
	   * Parse the mappings in a string in to a data structure which we can easily
	   * query (the ordered arrays in the `this.__generatedMappings` and
	   * `this.__originalMappings` properties).
	   */
	  _parseMappings(aStr, aSourceRoot) {
	    throw new Error("Subclasses must implement _parseMappings");
	  }

	  /**
	   * Iterate over each mapping between an original source/line/column and a
	   * generated line/column in this source map.
	   *
	   * @param Function aCallback
	   *        The function that is called with each mapping.
	   * @param Object aContext
	   *        Optional. If specified, this object will be the value of `this` every
	   *        time that `aCallback` is called.
	   * @param aOrder
	   *        Either `SourceMapConsumer.GENERATED_ORDER` or
	   *        `SourceMapConsumer.ORIGINAL_ORDER`. Specifies whether you want to
	   *        iterate over the mappings sorted by the generated file's line/column
	   *        order or the original's source/line/column order, respectively. Defaults to
	   *        `SourceMapConsumer.GENERATED_ORDER`.
	   */
	  eachMapping(aCallback, aContext, aOrder) {
	    throw new Error("Subclasses must implement eachMapping");
	  }

	  /**
	   * Returns all generated line and column information for the original source,
	   * line, and column provided. If no column is provided, returns all mappings
	   * corresponding to a either the line we are searching for or the next
	   * closest line that has any mappings. Otherwise, returns all mappings
	   * corresponding to the given line and either the column we are searching for
	   * or the next closest column that has any offsets.
	   *
	   * The only argument is an object with the following properties:
	   *
	   *   - source: The filename of the original source.
	   *   - line: The line number in the original source.  The line number is 1-based.
	   *   - column: Optional. the column number in the original source.
	   *    The column number is 0-based.
	   *
	   * and an array of objects is returned, each with the following properties:
	   *
	   *   - line: The line number in the generated source, or null.  The
	   *    line number is 1-based.
	   *   - column: The column number in the generated source, or null.
	   *    The column number is 0-based.
	   */
	  allGeneratedPositionsFor(aArgs) {
	    throw new Error("Subclasses must implement allGeneratedPositionsFor");
	  }

	  destroy() {
	    throw new Error("Subclasses must implement destroy");
	  }
	}

	/**
	 * The version of the source mapping spec that we are consuming.
	 */
	SourceMapConsumer.prototype._version = 3;
	SourceMapConsumer.GENERATED_ORDER = 1;
	SourceMapConsumer.ORIGINAL_ORDER = 2;

	SourceMapConsumer.GREATEST_LOWER_BOUND = 1;
	SourceMapConsumer.LEAST_UPPER_BOUND = 2;

	var SourceMapConsumer_1 = SourceMapConsumer;

	/**
	 * A BasicSourceMapConsumer instance represents a parsed source map which we can
	 * query for information about the original file positions by giving it a file
	 * position in the generated source.
	 *
	 * The first parameter is the raw source map (either as a JSON string, or
	 * already parsed to an object). According to the spec, source maps have the
	 * following attributes:
	 *
	 *   - version: Which version of the source map spec this map is following.
	 *   - sources: An array of URLs to the original source files.
	 *   - names: An array of identifiers which can be referenced by individual mappings.
	 *   - sourceRoot: Optional. The URL root from which all sources are relative.
	 *   - sourcesContent: Optional. An array of contents of the original source files.
	 *   - mappings: A string of base64 VLQs which contain the actual mappings.
	 *   - file: Optional. The generated file this source map is associated with.
	 *
	 * Here is an example source map, taken from the source map spec[0]:
	 *
	 *     {
	 *       version : 3,
	 *       file: "out.js",
	 *       sourceRoot : "",
	 *       sources: ["foo.js", "bar.js"],
	 *       names: ["src", "maps", "are", "fun"],
	 *       mappings: "AA,AB;;ABCDE;"
	 *     }
	 *
	 * The second parameter, if given, is a string whose value is the URL
	 * at which the source map was found.  This URL is used to compute the
	 * sources array.
	 *
	 * [0]: https://docs.google.com/document/d/1U1RGAehQwRypUTovF1KRlpiOFze0b-_2gc6fAH0KY0k/edit?pli=1#
	 */
	class BasicSourceMapConsumer extends SourceMapConsumer {
	  constructor(aSourceMap, aSourceMapURL) {
	    return super(INTERNAL).then(that => {
	      let sourceMap = aSourceMap;
	      if (typeof aSourceMap === "string") {
	        sourceMap = util.parseSourceMapInput(aSourceMap);
	      }

	      const version = util.getArg(sourceMap, "version");
	      let sources = util.getArg(sourceMap, "sources");
	      // Sass 3.3 leaves out the 'names' array, so we deviate from the spec (which
	      // requires the array) to play nice here.
	      const names = util.getArg(sourceMap, "names", []);
	      let sourceRoot = util.getArg(sourceMap, "sourceRoot", null);
	      const sourcesContent = util.getArg(sourceMap, "sourcesContent", null);
	      const mappings = util.getArg(sourceMap, "mappings");
	      const file = util.getArg(sourceMap, "file", null);

	      // Once again, Sass deviates from the spec and supplies the version as a
	      // string rather than a number, so we use loose equality checking here.
	      if (version != that._version) {
	        throw new Error("Unsupported version: " + version);
	      }

	      if (sourceRoot) {
	        sourceRoot = util.normalize(sourceRoot);
	      }

	      sources = sources
	        .map(String)
	        // Some source maps produce relative source paths like "./foo.js" instead of
	        // "foo.js".  Normalize these first so that future comparisons will succeed.
	        // See bugzil.la/1090768.
	        .map(util.normalize)
	        // Always ensure that absolute sources are internally stored relative to
	        // the source root, if the source root is absolute. Not doing this would
	        // be particularly problematic when the source root is a prefix of the
	        // source (valid, but why??). See github issue #199 and bugzil.la/1188982.
	        .map(function(source) {
	          return sourceRoot && util.isAbsolute(sourceRoot) && util.isAbsolute(source)
	            ? util.relative(sourceRoot, source)
	            : source;
	        });

	      // Pass `true` below to allow duplicate names and sources. While source maps
	      // are intended to be compressed and deduplicated, the TypeScript compiler
	      // sometimes generates source maps with duplicates in them. See Github issue
	      // #72 and bugzil.la/889492.
	      that._names = ArraySet$2.fromArray(names.map(String), true);
	      that._sources = ArraySet$2.fromArray(sources, true);

	      that._absoluteSources = that._sources.toArray().map(function(s) {
	        return util.computeSourceURL(sourceRoot, s, aSourceMapURL);
	      });

	      that.sourceRoot = sourceRoot;
	      that.sourcesContent = sourcesContent;
	      that._mappings = mappings;
	      that._sourceMapURL = aSourceMapURL;
	      that.file = file;

	      that._computedColumnSpans = false;
	      that._mappingsPtr = 0;
	      that._wasm = null;

	      return wasm().then(w => {
	        that._wasm = w;
	        return that;
	      });
	    });
	  }

	  /**
	   * Utility function to find the index of a source.  Returns -1 if not
	   * found.
	   */
	  _findSourceIndex(aSource) {
	    let relativeSource = aSource;
	    if (this.sourceRoot != null) {
	      relativeSource = util.relative(this.sourceRoot, relativeSource);
	    }

	    if (this._sources.has(relativeSource)) {
	      return this._sources.indexOf(relativeSource);
	    }

	    // Maybe aSource is an absolute URL as returned by |sources|.  In
	    // this case we can't simply undo the transform.
	    for (let i = 0; i < this._absoluteSources.length; ++i) {
	      if (this._absoluteSources[i] == aSource) {
	        return i;
	      }
	    }

	    return -1;
	  }

	  /**
	   * Create a BasicSourceMapConsumer from a SourceMapGenerator.
	   *
	   * @param SourceMapGenerator aSourceMap
	   *        The source map that will be consumed.
	   * @param String aSourceMapURL
	   *        The URL at which the source map can be found (optional)
	   * @returns BasicSourceMapConsumer
	   */
	  static fromSourceMap(aSourceMap, aSourceMapURL) {
	    return new BasicSourceMapConsumer(aSourceMap.toString());
	  }

	  get sources() {
	    return this._absoluteSources.slice();
	  }

	  _getMappingsPtr() {
	    if (this._mappingsPtr === 0) {
	      this._parseMappings(this._mappings, this.sourceRoot);
	    }

	    return this._mappingsPtr;
	  }

	  /**
	   * Parse the mappings in a string in to a data structure which we can easily
	   * query (the ordered arrays in the `this.__generatedMappings` and
	   * `this.__originalMappings` properties).
	   */
	  _parseMappings(aStr, aSourceRoot) {
	    const size = aStr.length;

	    const mappingsBufPtr = this._wasm.exports.allocate_mappings(size);
	    const mappingsBuf = new Uint8Array(this._wasm.exports.memory.buffer, mappingsBufPtr, size);
	    for (let i = 0; i < size; i++) {
	      mappingsBuf[i] = aStr.charCodeAt(i);
	    }

	    const mappingsPtr = this._wasm.exports.parse_mappings(mappingsBufPtr);

	    if (!mappingsPtr) {
	      const error = this._wasm.exports.get_last_error();
	      let msg = `Error parsing mappings (code ${error}): `;

	      // XXX: keep these error codes in sync with `fitzgen/source-map-mappings`.
	      switch (error) {
	        case 1:
	          msg += "the mappings contained a negative line, column, source index, or name index";
	          break;
	        case 2:
	          msg += "the mappings contained a number larger than 2**32";
	          break;
	        case 3:
	          msg += "reached EOF while in the middle of parsing a VLQ";
	          break;
	        case 4:
	          msg += "invalid base 64 character while parsing a VLQ";
	          break;
	        default:
	          msg += "unknown error code";
	          break;
	      }

	      throw new Error(msg);
	    }

	    this._mappingsPtr = mappingsPtr;
	  }

	  eachMapping(aCallback, aContext, aOrder) {
	    const context = aContext || null;
	    const order = aOrder || SourceMapConsumer.GENERATED_ORDER;
	    const sourceRoot = this.sourceRoot;

	    this._wasm.withMappingCallback(
	      mapping => {
	        if (mapping.source !== null) {
	          mapping.source = this._sources.at(mapping.source);
	          mapping.source = util.computeSourceURL(sourceRoot, mapping.source, this._sourceMapURL);

	          if (mapping.name !== null) {
	            mapping.name = this._names.at(mapping.name);
	          }
	        }

	        aCallback.call(context, mapping);
	      },
	      () => {
	        switch (order) {
	        case SourceMapConsumer.GENERATED_ORDER:
	          this._wasm.exports.by_generated_location(this._getMappingsPtr());
	          break;
	        case SourceMapConsumer.ORIGINAL_ORDER:
	          this._wasm.exports.by_original_location(this._getMappingsPtr());
	          break;
	        default:
	          throw new Error("Unknown order of iteration.");
	        }
	      }
	    );
	  }

	  allGeneratedPositionsFor(aArgs) {
	    let source = util.getArg(aArgs, "source");
	    const originalLine = util.getArg(aArgs, "line");
	    const originalColumn = aArgs.column || 0;

	    source = this._findSourceIndex(source);
	    if (source < 0) {
	      return [];
	    }

	    if (originalLine < 1) {
	      throw new Error("Line numbers must be >= 1");
	    }

	    if (originalColumn < 0) {
	      throw new Error("Column numbers must be >= 0");
	    }

	    const mappings = [];

	    this._wasm.withMappingCallback(
	      m => {
	        let lastColumn = m.lastGeneratedColumn;
	        if (this._computedColumnSpans && lastColumn === null) {
	          lastColumn = Infinity;
	        }
	        mappings.push({
	          line: m.generatedLine,
	          column: m.generatedColumn,
	          lastColumn,
	        });
	      }, () => {
	        this._wasm.exports.all_generated_locations_for(
	          this._getMappingsPtr(),
	          source,
	          originalLine - 1,
	          "column" in aArgs,
	          originalColumn
	        );
	      }
	    );

	    return mappings;
	  }

	  destroy() {
	    if (this._mappingsPtr !== 0) {
	      this._wasm.exports.free_mappings(this._mappingsPtr);
	      this._mappingsPtr = 0;
	    }
	  }

	  /**
	   * Compute the last column for each generated mapping. The last column is
	   * inclusive.
	   */
	  computeColumnSpans() {
	    if (this._computedColumnSpans) {
	      return;
	    }

	    this._wasm.exports.compute_column_spans(this._getMappingsPtr());
	    this._computedColumnSpans = true;
	  }

	  /**
	   * Returns the original source, line, and column information for the generated
	   * source's line and column positions provided. The only argument is an object
	   * with the following properties:
	   *
	   *   - line: The line number in the generated source.  The line number
	   *     is 1-based.
	   *   - column: The column number in the generated source.  The column
	   *     number is 0-based.
	   *   - bias: Either 'SourceMapConsumer.GREATEST_LOWER_BOUND' or
	   *     'SourceMapConsumer.LEAST_UPPER_BOUND'. Specifies whether to return the
	   *     closest element that is smaller than or greater than the one we are
	   *     searching for, respectively, if the exact element cannot be found.
	   *     Defaults to 'SourceMapConsumer.GREATEST_LOWER_BOUND'.
	   *
	   * and an object is returned with the following properties:
	   *
	   *   - source: The original source file, or null.
	   *   - line: The line number in the original source, or null.  The
	   *     line number is 1-based.
	   *   - column: The column number in the original source, or null.  The
	   *     column number is 0-based.
	   *   - name: The original identifier, or null.
	   */
	  originalPositionFor(aArgs) {
	    const needle = {
	      generatedLine: util.getArg(aArgs, "line"),
	      generatedColumn: util.getArg(aArgs, "column")
	    };

	    if (needle.generatedLine < 1) {
	      throw new Error("Line numbers must be >= 1");
	    }

	    if (needle.generatedColumn < 0) {
	      throw new Error("Column numbers must be >= 0");
	    }

	    let bias = util.getArg(aArgs, "bias", SourceMapConsumer.GREATEST_LOWER_BOUND);
	    if (bias == null) {
	      bias = SourceMapConsumer.GREATEST_LOWER_BOUND;
	    }

	    let mapping;
	    this._wasm.withMappingCallback(m => mapping = m, () => {
	      this._wasm.exports.original_location_for(
	        this._getMappingsPtr(),
	        needle.generatedLine - 1,
	        needle.generatedColumn,
	        bias
	      );
	    });

	    if (mapping) {
	      if (mapping.generatedLine === needle.generatedLine) {
	        let source = util.getArg(mapping, "source", null);
	        if (source !== null) {
	          source = this._sources.at(source);
	          source = util.computeSourceURL(this.sourceRoot, source, this._sourceMapURL);
	        }

	        let name = util.getArg(mapping, "name", null);
	        if (name !== null) {
	          name = this._names.at(name);
	        }

	        return {
	          source,
	          line: util.getArg(mapping, "originalLine", null),
	          column: util.getArg(mapping, "originalColumn", null),
	          name
	        };
	      }
	    }

	    return {
	      source: null,
	      line: null,
	      column: null,
	      name: null
	    };
	  }

	  /**
	   * Return true if we have the source content for every source in the source
	   * map, false otherwise.
	   */
	  hasContentsOfAllSources() {
	    if (!this.sourcesContent) {
	      return false;
	    }
	    return this.sourcesContent.length >= this._sources.size() &&
	      !this.sourcesContent.some(function(sc) { return sc == null; });
	  }

	  /**
	   * Returns the original source content. The only argument is the url of the
	   * original source file. Returns null if no original source content is
	   * available.
	   */
	  sourceContentFor(aSource, nullOnMissing) {
	    if (!this.sourcesContent) {
	      return null;
	    }

	    const index = this._findSourceIndex(aSource);
	    if (index >= 0) {
	      return this.sourcesContent[index];
	    }

	    let relativeSource = aSource;
	    if (this.sourceRoot != null) {
	      relativeSource = util.relative(this.sourceRoot, relativeSource);
	    }

	    let url;
	    if (this.sourceRoot != null
	        && (url = util.urlParse(this.sourceRoot))) {
	      // XXX: file:// URIs and absolute paths lead to unexpected behavior for
	      // many users. We can help them out when they expect file:// URIs to
	      // behave like it would if they were running a local HTTP server. See
	      // https://bugzilla.mozilla.org/show_bug.cgi?id=885597.
	      const fileUriAbsPath = relativeSource.replace(/^file:\/\//, "");
	      if (url.scheme == "file"
	          && this._sources.has(fileUriAbsPath)) {
	        return this.sourcesContent[this._sources.indexOf(fileUriAbsPath)];
	      }

	      if ((!url.path || url.path == "/")
	          && this._sources.has("/" + relativeSource)) {
	        return this.sourcesContent[this._sources.indexOf("/" + relativeSource)];
	      }
	    }

	    // This function is used recursively from
	    // IndexedSourceMapConsumer.prototype.sourceContentFor. In that case, we
	    // don't want to throw if we can't find the source - we just want to
	    // return null, so we provide a flag to exit gracefully.
	    if (nullOnMissing) {
	      return null;
	    }

	    throw new Error('"' + relativeSource + '" is not in the SourceMap.');
	  }

	  /**
	   * Returns the generated line and column information for the original source,
	   * line, and column positions provided. The only argument is an object with
	   * the following properties:
	   *
	   *   - source: The filename of the original source.
	   *   - line: The line number in the original source.  The line number
	   *     is 1-based.
	   *   - column: The column number in the original source.  The column
	   *     number is 0-based.
	   *   - bias: Either 'SourceMapConsumer.GREATEST_LOWER_BOUND' or
	   *     'SourceMapConsumer.LEAST_UPPER_BOUND'. Specifies whether to return the
	   *     closest element that is smaller than or greater than the one we are
	   *     searching for, respectively, if the exact element cannot be found.
	   *     Defaults to 'SourceMapConsumer.GREATEST_LOWER_BOUND'.
	   *
	   * and an object is returned with the following properties:
	   *
	   *   - line: The line number in the generated source, or null.  The
	   *     line number is 1-based.
	   *   - column: The column number in the generated source, or null.
	   *     The column number is 0-based.
	   */
	  generatedPositionFor(aArgs) {
	    let source = util.getArg(aArgs, "source");
	    source = this._findSourceIndex(source);
	    if (source < 0) {
	      return {
	        line: null,
	        column: null,
	        lastColumn: null
	      };
	    }

	    const needle = {
	      source,
	      originalLine: util.getArg(aArgs, "line"),
	      originalColumn: util.getArg(aArgs, "column")
	    };

	    if (needle.originalLine < 1) {
	      throw new Error("Line numbers must be >= 1");
	    }

	    if (needle.originalColumn < 0) {
	      throw new Error("Column numbers must be >= 0");
	    }

	    let bias = util.getArg(aArgs, "bias", SourceMapConsumer.GREATEST_LOWER_BOUND);
	    if (bias == null) {
	      bias = SourceMapConsumer.GREATEST_LOWER_BOUND;
	    }

	    let mapping;
	    this._wasm.withMappingCallback(m => mapping = m, () => {
	      this._wasm.exports.generated_location_for(
	        this._getMappingsPtr(),
	        needle.source,
	        needle.originalLine - 1,
	        needle.originalColumn,
	        bias
	      );
	    });

	    if (mapping) {
	      if (mapping.source === needle.source) {
	        let lastColumn = mapping.lastGeneratedColumn;
	        if (this._computedColumnSpans && lastColumn === null) {
	          lastColumn = Infinity;
	        }
	        return {
	          line: util.getArg(mapping, "generatedLine", null),
	          column: util.getArg(mapping, "generatedColumn", null),
	          lastColumn,
	        };
	      }
	    }

	    return {
	      line: null,
	      column: null,
	      lastColumn: null
	    };
	  }
	}

	BasicSourceMapConsumer.prototype.consumer = SourceMapConsumer;
	var BasicSourceMapConsumer_1 = BasicSourceMapConsumer;

	/**
	 * An IndexedSourceMapConsumer instance represents a parsed source map which
	 * we can query for information. It differs from BasicSourceMapConsumer in
	 * that it takes "indexed" source maps (i.e. ones with a "sections" field) as
	 * input.
	 *
	 * The first parameter is a raw source map (either as a JSON string, or already
	 * parsed to an object). According to the spec for indexed source maps, they
	 * have the following attributes:
	 *
	 *   - version: Which version of the source map spec this map is following.
	 *   - file: Optional. The generated file this source map is associated with.
	 *   - sections: A list of section definitions.
	 *
	 * Each value under the "sections" field has two fields:
	 *   - offset: The offset into the original specified at which this section
	 *       begins to apply, defined as an object with a "line" and "column"
	 *       field.
	 *   - map: A source map definition. This source map could also be indexed,
	 *       but doesn't have to be.
	 *
	 * Instead of the "map" field, it's also possible to have a "url" field
	 * specifying a URL to retrieve a source map from, but that's currently
	 * unsupported.
	 *
	 * Here's an example source map, taken from the source map spec[0], but
	 * modified to omit a section which uses the "url" field.
	 *
	 *  {
	 *    version : 3,
	 *    file: "app.js",
	 *    sections: [{
	 *      offset: {line:100, column:10},
	 *      map: {
	 *        version : 3,
	 *        file: "section.js",
	 *        sources: ["foo.js", "bar.js"],
	 *        names: ["src", "maps", "are", "fun"],
	 *        mappings: "AAAA,E;;ABCDE;"
	 *      }
	 *    }],
	 *  }
	 *
	 * The second parameter, if given, is a string whose value is the URL
	 * at which the source map was found.  This URL is used to compute the
	 * sources array.
	 *
	 * [0]: https://docs.google.com/document/d/1U1RGAehQwRypUTovF1KRlpiOFze0b-_2gc6fAH0KY0k/edit#heading=h.535es3xeprgt
	 */
	class IndexedSourceMapConsumer extends SourceMapConsumer {
	  constructor(aSourceMap, aSourceMapURL) {
	    return super(INTERNAL).then(that => {
	      let sourceMap = aSourceMap;
	      if (typeof aSourceMap === "string") {
	        sourceMap = util.parseSourceMapInput(aSourceMap);
	      }

	      const version = util.getArg(sourceMap, "version");
	      const sections = util.getArg(sourceMap, "sections");

	      if (version != that._version) {
	        throw new Error("Unsupported version: " + version);
	      }

	      that._sources = new ArraySet$2();
	      that._names = new ArraySet$2();
	      that.__generatedMappings = null;
	      that.__originalMappings = null;
	      that.__generatedMappingsUnsorted = null;
	      that.__originalMappingsUnsorted = null;

	      let lastOffset = {
	        line: -1,
	        column: 0
	      };
	      return Promise.all(sections.map(s => {
	        if (s.url) {
	          // The url field will require support for asynchronicity.
	          // See https://github.com/mozilla/source-map/issues/16
	          throw new Error("Support for url field in sections not implemented.");
	        }
	        const offset = util.getArg(s, "offset");
	        const offsetLine = util.getArg(offset, "line");
	        const offsetColumn = util.getArg(offset, "column");

	        if (offsetLine < lastOffset.line ||
	            (offsetLine === lastOffset.line && offsetColumn < lastOffset.column)) {
	          throw new Error("Section offsets must be ordered and non-overlapping.");
	        }
	        lastOffset = offset;

	        const cons = new SourceMapConsumer(util.getArg(s, "map"), aSourceMapURL);
	        return cons.then(consumer => {
	          return {
	            generatedOffset: {
	              // The offset fields are 0-based, but we use 1-based indices when
	              // encoding/decoding from VLQ.
	              generatedLine: offsetLine + 1,
	              generatedColumn: offsetColumn + 1
	            },
	            consumer
	          };
	        });
	      })).then(s => {
	        that._sections = s;
	        return that;
	      });
	    });
	  }

	  // `__generatedMappings` and `__originalMappings` are arrays that hold the
	  // parsed mapping coordinates from the source map's "mappings" attribute. They
	  // are lazily instantiated, accessed via the `_generatedMappings` and
	  // `_originalMappings` getters respectively, and we only parse the mappings
	  // and create these arrays once queried for a source location. We jump through
	  // these hoops because there can be many thousands of mappings, and parsing
	  // them is expensive, so we only want to do it if we must.
	  //
	  // Each object in the arrays is of the form:
	  //
	  //     {
	  //       generatedLine: The line number in the generated code,
	  //       generatedColumn: The column number in the generated code,
	  //       source: The path to the original source file that generated this
	  //               chunk of code,
	  //       originalLine: The line number in the original source that
	  //                     corresponds to this chunk of generated code,
	  //       originalColumn: The column number in the original source that
	  //                       corresponds to this chunk of generated code,
	  //       name: The name of the original symbol which generated this chunk of
	  //             code.
	  //     }
	  //
	  // All properties except for `generatedLine` and `generatedColumn` can be
	  // `null`.
	  //
	  // `_generatedMappings` is ordered by the generated positions.
	  //
	  // `_originalMappings` is ordered by the original positions.
	  get _generatedMappings() {
	    if (!this.__generatedMappings) {
	      this._sortGeneratedMappings();
	    }

	    return this.__generatedMappings;
	  }

	  get _originalMappings() {
	    if (!this.__originalMappings) {
	      this._sortOriginalMappings();
	    }

	    return this.__originalMappings;
	  }

	  get _generatedMappingsUnsorted() {
	    if (!this.__generatedMappingsUnsorted) {
	      this._parseMappings(this._mappings, this.sourceRoot);
	    }

	    return this.__generatedMappingsUnsorted;
	  }

	  get _originalMappingsUnsorted() {
	    if (!this.__originalMappingsUnsorted) {
	      this._parseMappings(this._mappings, this.sourceRoot);
	    }

	    return this.__originalMappingsUnsorted;
	  }

	  _sortGeneratedMappings() {
	    const mappings = this._generatedMappingsUnsorted;
	    mappings.sort(util.compareByGeneratedPositionsDeflated);
	    this.__generatedMappings = mappings;
	  }

	  _sortOriginalMappings() {
	    const mappings = this._originalMappingsUnsorted;
	    mappings.sort(util.compareByOriginalPositions);
	    this.__originalMappings = mappings;
	  }

	  /**
	   * The list of original sources.
	   */
	  get sources() {
	    const sources = [];
	    for (let i = 0; i < this._sections.length; i++) {
	      for (let j = 0; j < this._sections[i].consumer.sources.length; j++) {
	        sources.push(this._sections[i].consumer.sources[j]);
	      }
	    }
	    return sources;
	  }

	  /**
	   * Returns the original source, line, and column information for the generated
	   * source's line and column positions provided. The only argument is an object
	   * with the following properties:
	   *
	   *   - line: The line number in the generated source.  The line number
	   *     is 1-based.
	   *   - column: The column number in the generated source.  The column
	   *     number is 0-based.
	   *
	   * and an object is returned with the following properties:
	   *
	   *   - source: The original source file, or null.
	   *   - line: The line number in the original source, or null.  The
	   *     line number is 1-based.
	   *   - column: The column number in the original source, or null.  The
	   *     column number is 0-based.
	   *   - name: The original identifier, or null.
	   */
	  originalPositionFor(aArgs) {
	    const needle = {
	      generatedLine: util.getArg(aArgs, "line"),
	      generatedColumn: util.getArg(aArgs, "column")
	    };

	    // Find the section containing the generated position we're trying to map
	    // to an original position.
	    const sectionIndex = binarySearch.search(needle, this._sections,
	      function(aNeedle, section) {
	        const cmp = aNeedle.generatedLine - section.generatedOffset.generatedLine;
	        if (cmp) {
	          return cmp;
	        }

	        return (aNeedle.generatedColumn -
	                section.generatedOffset.generatedColumn);
	      });
	    const section = this._sections[sectionIndex];

	    if (!section) {
	      return {
	        source: null,
	        line: null,
	        column: null,
	        name: null
	      };
	    }

	    return section.consumer.originalPositionFor({
	      line: needle.generatedLine -
	        (section.generatedOffset.generatedLine - 1),
	      column: needle.generatedColumn -
	        (section.generatedOffset.generatedLine === needle.generatedLine
	         ? section.generatedOffset.generatedColumn - 1
	         : 0),
	      bias: aArgs.bias
	    });
	  }

	  /**
	   * Return true if we have the source content for every source in the source
	   * map, false otherwise.
	   */
	  hasContentsOfAllSources() {
	    return this._sections.every(function(s) {
	      return s.consumer.hasContentsOfAllSources();
	    });
	  }

	  /**
	   * Returns the original source content. The only argument is the url of the
	   * original source file. Returns null if no original source content is
	   * available.
	   */
	  sourceContentFor(aSource, nullOnMissing) {
	    for (let i = 0; i < this._sections.length; i++) {
	      const section = this._sections[i];

	      const content = section.consumer.sourceContentFor(aSource, true);
	      if (content) {
	        return content;
	      }
	    }
	    if (nullOnMissing) {
	      return null;
	    }
	    throw new Error('"' + aSource + '" is not in the SourceMap.');
	  }

	  /**
	   * Returns the generated line and column information for the original source,
	   * line, and column positions provided. The only argument is an object with
	   * the following properties:
	   *
	   *   - source: The filename of the original source.
	   *   - line: The line number in the original source.  The line number
	   *     is 1-based.
	   *   - column: The column number in the original source.  The column
	   *     number is 0-based.
	   *
	   * and an object is returned with the following properties:
	   *
	   *   - line: The line number in the generated source, or null.  The
	   *     line number is 1-based.
	   *   - column: The column number in the generated source, or null.
	   *     The column number is 0-based.
	   */
	  generatedPositionFor(aArgs) {
	    for (let i = 0; i < this._sections.length; i++) {
	      const section = this._sections[i];

	      // Only consider this section if the requested source is in the list of
	      // sources of the consumer.
	      if (section.consumer._findSourceIndex(util.getArg(aArgs, "source")) === -1) {
	        continue;
	      }
	      const generatedPosition = section.consumer.generatedPositionFor(aArgs);
	      if (generatedPosition) {
	        const ret = {
	          line: generatedPosition.line +
	            (section.generatedOffset.generatedLine - 1),
	          column: generatedPosition.column +
	            (section.generatedOffset.generatedLine === generatedPosition.line
	             ? section.generatedOffset.generatedColumn - 1
	             : 0)
	        };
	        return ret;
	      }
	    }

	    return {
	      line: null,
	      column: null
	    };
	  }

	  /**
	   * Parse the mappings in a string in to a data structure which we can easily
	   * query (the ordered arrays in the `this.__generatedMappings` and
	   * `this.__originalMappings` properties).
	   */
	  _parseMappings(aStr, aSourceRoot) {
	    const generatedMappings = this.__generatedMappingsUnsorted = [];
	    const originalMappings = this.__originalMappingsUnsorted = [];
	    for (let i = 0; i < this._sections.length; i++) {
	      const section = this._sections[i];

	      const sectionMappings = [];
	      section.consumer.eachMapping(m => sectionMappings.push(m));

	      for (let j = 0; j < sectionMappings.length; j++) {
	        const mapping = sectionMappings[j];

	        // TODO: test if null is correct here.  The original code used
	        // `source`, which would actually have gotten used as null because
	        // var's get hoisted.
	        // See: https://github.com/mozilla/source-map/issues/333
	        let source = util.computeSourceURL(section.consumer.sourceRoot, null, this._sourceMapURL);
	        this._sources.add(source);
	        source = this._sources.indexOf(source);

	        let name = null;
	        if (mapping.name) {
	          this._names.add(mapping.name);
	          name = this._names.indexOf(mapping.name);
	        }

	        // The mappings coming from the consumer for the section have
	        // generated positions relative to the start of the section, so we
	        // need to offset them to be relative to the start of the concatenated
	        // generated file.
	        const adjustedMapping = {
	          source,
	          generatedLine: mapping.generatedLine +
	            (section.generatedOffset.generatedLine - 1),
	          generatedColumn: mapping.generatedColumn +
	            (section.generatedOffset.generatedLine === mapping.generatedLine
	            ? section.generatedOffset.generatedColumn - 1
	            : 0),
	          originalLine: mapping.originalLine,
	          originalColumn: mapping.originalColumn,
	          name
	        };

	        generatedMappings.push(adjustedMapping);
	        if (typeof adjustedMapping.originalLine === "number") {
	          originalMappings.push(adjustedMapping);
	        }
	      }
	    }
	  }

	  eachMapping(aCallback, aContext, aOrder) {
	    const context = aContext || null;
	    const order = aOrder || SourceMapConsumer.GENERATED_ORDER;

	    let mappings;
	    switch (order) {
	    case SourceMapConsumer.GENERATED_ORDER:
	      mappings = this._generatedMappings;
	      break;
	    case SourceMapConsumer.ORIGINAL_ORDER:
	      mappings = this._originalMappings;
	      break;
	    default:
	      throw new Error("Unknown order of iteration.");
	    }

	    const sourceRoot = this.sourceRoot;
	    mappings.map(function(mapping) {
	      let source = null;
	      if (mapping.source !== null) {
	        source = this._sources.at(mapping.source);
	        source = util.computeSourceURL(sourceRoot, source, this._sourceMapURL);
	      }
	      return {
	        source,
	        generatedLine: mapping.generatedLine,
	        generatedColumn: mapping.generatedColumn,
	        originalLine: mapping.originalLine,
	        originalColumn: mapping.originalColumn,
	        name: mapping.name === null ? null : this._names.at(mapping.name)
	      };
	    }, this).forEach(aCallback, context);
	  }

	  /**
	   * Find the mapping that best matches the hypothetical "needle" mapping that
	   * we are searching for in the given "haystack" of mappings.
	   */
	  _findMapping(aNeedle, aMappings, aLineName,
	              aColumnName, aComparator, aBias) {
	    // To return the position we are searching for, we must first find the
	    // mapping for the given position and then return the opposite position it
	    // points to. Because the mappings are sorted, we can use binary search to
	    // find the best mapping.

	    if (aNeedle[aLineName] <= 0) {
	      throw new TypeError("Line must be greater than or equal to 1, got "
	                          + aNeedle[aLineName]);
	    }
	    if (aNeedle[aColumnName] < 0) {
	      throw new TypeError("Column must be greater than or equal to 0, got "
	                          + aNeedle[aColumnName]);
	    }

	    return binarySearch.search(aNeedle, aMappings, aComparator, aBias);
	  }

	  allGeneratedPositionsFor(aArgs) {
	    const line = util.getArg(aArgs, "line");

	    // When there is no exact match, BasicSourceMapConsumer.prototype._findMapping
	    // returns the index of the closest mapping less than the needle. By
	    // setting needle.originalColumn to 0, we thus find the last mapping for
	    // the given line, provided such a mapping exists.
	    const needle = {
	      source: util.getArg(aArgs, "source"),
	      originalLine: line,
	      originalColumn: util.getArg(aArgs, "column", 0)
	    };

	    needle.source = this._findSourceIndex(needle.source);
	    if (needle.source < 0) {
	      return [];
	    }

	    if (needle.originalLine < 1) {
	      throw new Error("Line numbers must be >= 1");
	    }

	    if (needle.originalColumn < 0) {
	      throw new Error("Column numbers must be >= 0");
	    }

	    const mappings = [];

	    let index = this._findMapping(needle,
	                                  this._originalMappings,
	                                  "originalLine",
	                                  "originalColumn",
	                                  util.compareByOriginalPositions,
	                                  binarySearch.LEAST_UPPER_BOUND);
	    if (index >= 0) {
	      let mapping = this._originalMappings[index];

	      if (aArgs.column === undefined) {
	        const originalLine = mapping.originalLine;

	        // Iterate until either we run out of mappings, or we run into
	        // a mapping for a different line than the one we found. Since
	        // mappings are sorted, this is guaranteed to find all mappings for
	        // the line we found.
	        while (mapping && mapping.originalLine === originalLine) {
	          let lastColumn = mapping.lastGeneratedColumn;
	          if (this._computedColumnSpans && lastColumn === null) {
	            lastColumn = Infinity;
	          }
	          mappings.push({
	            line: util.getArg(mapping, "generatedLine", null),
	            column: util.getArg(mapping, "generatedColumn", null),
	            lastColumn,
	          });

	          mapping = this._originalMappings[++index];
	        }
	      } else {
	        const originalColumn = mapping.originalColumn;

	        // Iterate until either we run out of mappings, or we run into
	        // a mapping for a different line than the one we were searching for.
	        // Since mappings are sorted, this is guaranteed to find all mappings for
	        // the line we are searching for.
	        while (mapping &&
	               mapping.originalLine === line &&
	               mapping.originalColumn == originalColumn) {
	          let lastColumn = mapping.lastGeneratedColumn;
	          if (this._computedColumnSpans && lastColumn === null) {
	            lastColumn = Infinity;
	          }
	          mappings.push({
	            line: util.getArg(mapping, "generatedLine", null),
	            column: util.getArg(mapping, "generatedColumn", null),
	            lastColumn,
	          });

	          mapping = this._originalMappings[++index];
	        }
	      }
	    }

	    return mappings;
	  }

	  destroy() {
	    for (let i = 0; i < this._sections.length; i++) {
	      this._sections[i].consumer.destroy();
	    }
	  }
	}
	var IndexedSourceMapConsumer_1 = IndexedSourceMapConsumer;

	/*
	 * Cheat to get around inter-twingled classes.  `factory()` can be at the end
	 * where it has access to non-hoisted classes, but it gets hoisted itself.
	 */
	function _factory(aSourceMap, aSourceMapURL) {
	  let sourceMap = aSourceMap;
	  if (typeof aSourceMap === "string") {
	    sourceMap = util.parseSourceMapInput(aSourceMap);
	  }

	  const consumer = sourceMap.sections != null
	      ? new IndexedSourceMapConsumer(sourceMap, aSourceMapURL)
	      : new BasicSourceMapConsumer(sourceMap, aSourceMapURL);
	  return Promise.resolve(consumer);
	}

	function _factoryBSM(aSourceMap, aSourceMapURL) {
	  return BasicSourceMapConsumer.fromSourceMap(aSourceMap, aSourceMapURL);
	}

	var sourceMapConsumer = {
		SourceMapConsumer: SourceMapConsumer_1,
		BasicSourceMapConsumer: BasicSourceMapConsumer_1,
		IndexedSourceMapConsumer: IndexedSourceMapConsumer_1
	};

	/* -*- Mode: js; js-indent-level: 2; -*- */
	/*
	 * Copyright 2011 Mozilla Foundation and contributors
	 * Licensed under the New BSD license. See LICENSE or:
	 * http://opensource.org/licenses/BSD-3-Clause
	 */

	const SourceMapGenerator$1 = sourceMapGenerator.SourceMapGenerator;


	// Matches a Windows-style `\r\n` newline or a `\n` newline used by all other
	// operating systems these days (capturing the result).
	const REGEX_NEWLINE = /(\r?\n)/;

	// Newline character code for charCodeAt() comparisons
	const NEWLINE_CODE = 10;

	// Private symbol for identifying `SourceNode`s when multiple versions of
	// the source-map library are loaded. This MUST NOT CHANGE across
	// versions!
	const isSourceNode = "$$$isSourceNode$$$";

	/**
	 * SourceNodes provide a way to abstract over interpolating/concatenating
	 * snippets of generated JavaScript source code while maintaining the line and
	 * column information associated with the original source code.
	 *
	 * @param aLine The original line number.
	 * @param aColumn The original column number.
	 * @param aSource The original source's filename.
	 * @param aChunks Optional. An array of strings which are snippets of
	 *        generated JS, or other SourceNodes.
	 * @param aName The original identifier.
	 */
	class SourceNode {
	  constructor(aLine, aColumn, aSource, aChunks, aName) {
	    this.children = [];
	    this.sourceContents = {};
	    this.line = aLine == null ? null : aLine;
	    this.column = aColumn == null ? null : aColumn;
	    this.source = aSource == null ? null : aSource;
	    this.name = aName == null ? null : aName;
	    this[isSourceNode] = true;
	    if (aChunks != null) this.add(aChunks);
	  }

	  /**
	   * Creates a SourceNode from generated code and a SourceMapConsumer.
	   *
	   * @param aGeneratedCode The generated code
	   * @param aSourceMapConsumer The SourceMap for the generated code
	   * @param aRelativePath Optional. The path that relative sources in the
	   *        SourceMapConsumer should be relative to.
	   */
	  static fromStringWithSourceMap(aGeneratedCode, aSourceMapConsumer, aRelativePath) {
	    // The SourceNode we want to fill with the generated code
	    // and the SourceMap
	    const node = new SourceNode();

	    // All even indices of this array are one line of the generated code,
	    // while all odd indices are the newlines between two adjacent lines
	    // (since `REGEX_NEWLINE` captures its match).
	    // Processed fragments are accessed by calling `shiftNextLine`.
	    const remainingLines = aGeneratedCode.split(REGEX_NEWLINE);
	    let remainingLinesIndex = 0;
	    const shiftNextLine = function() {
	      const lineContents = getNextLine();
	      // The last line of a file might not have a newline.
	      const newLine = getNextLine() || "";
	      return lineContents + newLine;

	      function getNextLine() {
	        return remainingLinesIndex < remainingLines.length ?
	            remainingLines[remainingLinesIndex++] : undefined;
	      }
	    };

	    // We need to remember the position of "remainingLines"
	    let lastGeneratedLine = 1, lastGeneratedColumn = 0;

	    // The generate SourceNodes we need a code range.
	    // To extract it current and last mapping is used.
	    // Here we store the last mapping.
	    let lastMapping = null;
	    let nextLine;

	    aSourceMapConsumer.eachMapping(function(mapping) {
	      if (lastMapping !== null) {
	        // We add the code from "lastMapping" to "mapping":
	        // First check if there is a new line in between.
	        if (lastGeneratedLine < mapping.generatedLine) {
	          // Associate first line with "lastMapping"
	          addMappingWithCode(lastMapping, shiftNextLine());
	          lastGeneratedLine++;
	          lastGeneratedColumn = 0;
	          // The remaining code is added without mapping
	        } else {
	          // There is no new line in between.
	          // Associate the code between "lastGeneratedColumn" and
	          // "mapping.generatedColumn" with "lastMapping"
	          nextLine = remainingLines[remainingLinesIndex] || "";
	          const code = nextLine.substr(0, mapping.generatedColumn -
	                                        lastGeneratedColumn);
	          remainingLines[remainingLinesIndex] = nextLine.substr(mapping.generatedColumn -
	                                              lastGeneratedColumn);
	          lastGeneratedColumn = mapping.generatedColumn;
	          addMappingWithCode(lastMapping, code);
	          // No more remaining code, continue
	          lastMapping = mapping;
	          return;
	        }
	      }
	      // We add the generated code until the first mapping
	      // to the SourceNode without any mapping.
	      // Each line is added as separate string.
	      while (lastGeneratedLine < mapping.generatedLine) {
	        node.add(shiftNextLine());
	        lastGeneratedLine++;
	      }
	      if (lastGeneratedColumn < mapping.generatedColumn) {
	        nextLine = remainingLines[remainingLinesIndex] || "";
	        node.add(nextLine.substr(0, mapping.generatedColumn));
	        remainingLines[remainingLinesIndex] = nextLine.substr(mapping.generatedColumn);
	        lastGeneratedColumn = mapping.generatedColumn;
	      }
	      lastMapping = mapping;
	    }, this);
	    // We have processed all mappings.
	    if (remainingLinesIndex < remainingLines.length) {
	      if (lastMapping) {
	        // Associate the remaining code in the current line with "lastMapping"
	        addMappingWithCode(lastMapping, shiftNextLine());
	      }
	      // and add the remaining lines without any mapping
	      node.add(remainingLines.splice(remainingLinesIndex).join(""));
	    }

	    // Copy sourcesContent into SourceNode
	    aSourceMapConsumer.sources.forEach(function(sourceFile) {
	      const content = aSourceMapConsumer.sourceContentFor(sourceFile);
	      if (content != null) {
	        if (aRelativePath != null) {
	          sourceFile = util.join(aRelativePath, sourceFile);
	        }
	        node.setSourceContent(sourceFile, content);
	      }
	    });

	    return node;

	    function addMappingWithCode(mapping, code) {
	      if (mapping === null || mapping.source === undefined) {
	        node.add(code);
	      } else {
	        const source = aRelativePath
	          ? util.join(aRelativePath, mapping.source)
	          : mapping.source;
	        node.add(new SourceNode(mapping.originalLine,
	                                mapping.originalColumn,
	                                source,
	                                code,
	                                mapping.name));
	      }
	    }
	  }

	  /**
	   * Add a chunk of generated JS to this source node.
	   *
	   * @param aChunk A string snippet of generated JS code, another instance of
	   *        SourceNode, or an array where each member is one of those things.
	   */
	  add(aChunk) {
	    if (Array.isArray(aChunk)) {
	      aChunk.forEach(function(chunk) {
	        this.add(chunk);
	      }, this);
	    } else if (aChunk[isSourceNode] || typeof aChunk === "string") {
	      if (aChunk) {
	        this.children.push(aChunk);
	      }
	    } else {
	      throw new TypeError(
	        "Expected a SourceNode, string, or an array of SourceNodes and strings. Got " + aChunk
	      );
	    }
	    return this;
	  }

	  /**
	   * Add a chunk of generated JS to the beginning of this source node.
	   *
	   * @param aChunk A string snippet of generated JS code, another instance of
	   *        SourceNode, or an array where each member is one of those things.
	   */
	  prepend(aChunk) {
	    if (Array.isArray(aChunk)) {
	      for (let i = aChunk.length - 1; i >= 0; i--) {
	        this.prepend(aChunk[i]);
	      }
	    } else if (aChunk[isSourceNode] || typeof aChunk === "string") {
	      this.children.unshift(aChunk);
	    } else {
	      throw new TypeError(
	        "Expected a SourceNode, string, or an array of SourceNodes and strings. Got " + aChunk
	      );
	    }
	    return this;
	  }

	  /**
	   * Walk over the tree of JS snippets in this node and its children. The
	   * walking function is called once for each snippet of JS and is passed that
	   * snippet and the its original associated source's line/column location.
	   *
	   * @param aFn The traversal function.
	   */
	  walk(aFn) {
	    let chunk;
	    for (let i = 0, len = this.children.length; i < len; i++) {
	      chunk = this.children[i];
	      if (chunk[isSourceNode]) {
	        chunk.walk(aFn);
	      } else if (chunk !== "") {
	        aFn(chunk, { source: this.source,
	                      line: this.line,
	                      column: this.column,
	                      name: this.name });
	      }
	    }
	  }

	  /**
	   * Like `String.prototype.join` except for SourceNodes. Inserts `aStr` between
	   * each of `this.children`.
	   *
	   * @param aSep The separator.
	   */
	  join(aSep) {
	    let newChildren;
	    let i;
	    const len = this.children.length;
	    if (len > 0) {
	      newChildren = [];
	      for (i = 0; i < len - 1; i++) {
	        newChildren.push(this.children[i]);
	        newChildren.push(aSep);
	      }
	      newChildren.push(this.children[i]);
	      this.children = newChildren;
	    }
	    return this;
	  }

	  /**
	   * Call String.prototype.replace on the very right-most source snippet. Useful
	   * for trimming whitespace from the end of a source node, etc.
	   *
	   * @param aPattern The pattern to replace.
	   * @param aReplacement The thing to replace the pattern with.
	   */
	  replaceRight(aPattern, aReplacement) {
	    const lastChild = this.children[this.children.length - 1];
	    if (lastChild[isSourceNode]) {
	      lastChild.replaceRight(aPattern, aReplacement);
	    } else if (typeof lastChild === "string") {
	      this.children[this.children.length - 1] = lastChild.replace(aPattern, aReplacement);
	    } else {
	      this.children.push("".replace(aPattern, aReplacement));
	    }
	    return this;
	  }

	  /**
	   * Set the source content for a source file. This will be added to the SourceMapGenerator
	   * in the sourcesContent field.
	   *
	   * @param aSourceFile The filename of the source file
	   * @param aSourceContent The content of the source file
	   */
	  setSourceContent(aSourceFile, aSourceContent) {
	    this.sourceContents[util.toSetString(aSourceFile)] = aSourceContent;
	  }

	  /**
	   * Walk over the tree of SourceNodes. The walking function is called for each
	   * source file content and is passed the filename and source content.
	   *
	   * @param aFn The traversal function.
	   */
	  walkSourceContents(aFn) {
	    for (let i = 0, len = this.children.length; i < len; i++) {
	      if (this.children[i][isSourceNode]) {
	        this.children[i].walkSourceContents(aFn);
	      }
	    }

	    const sources = Object.keys(this.sourceContents);
	    for (let i = 0, len = sources.length; i < len; i++) {
	      aFn(util.fromSetString(sources[i]), this.sourceContents[sources[i]]);
	    }
	  }

	  /**
	   * Return the string representation of this source node. Walks over the tree
	   * and concatenates all the various snippets together to one string.
	   */
	  toString() {
	    let str = "";
	    this.walk(function(chunk) {
	      str += chunk;
	    });
	    return str;
	  }

	  /**
	   * Returns the string representation of this source node along with a source
	   * map.
	   */
	  toStringWithSourceMap(aArgs) {
	    const generated = {
	      code: "",
	      line: 1,
	      column: 0
	    };
	    const map = new SourceMapGenerator$1(aArgs);
	    let sourceMappingActive = false;
	    let lastOriginalSource = null;
	    let lastOriginalLine = null;
	    let lastOriginalColumn = null;
	    let lastOriginalName = null;
	    this.walk(function(chunk, original) {
	      generated.code += chunk;
	      if (original.source !== null
	          && original.line !== null
	          && original.column !== null) {
	        if (lastOriginalSource !== original.source
	          || lastOriginalLine !== original.line
	          || lastOriginalColumn !== original.column
	          || lastOriginalName !== original.name) {
	          map.addMapping({
	            source: original.source,
	            original: {
	              line: original.line,
	              column: original.column
	            },
	            generated: {
	              line: generated.line,
	              column: generated.column
	            },
	            name: original.name
	          });
	        }
	        lastOriginalSource = original.source;
	        lastOriginalLine = original.line;
	        lastOriginalColumn = original.column;
	        lastOriginalName = original.name;
	        sourceMappingActive = true;
	      } else if (sourceMappingActive) {
	        map.addMapping({
	          generated: {
	            line: generated.line,
	            column: generated.column
	          }
	        });
	        lastOriginalSource = null;
	        sourceMappingActive = false;
	      }
	      for (let idx = 0, length = chunk.length; idx < length; idx++) {
	        if (chunk.charCodeAt(idx) === NEWLINE_CODE) {
	          generated.line++;
	          generated.column = 0;
	          // Mappings end at eol
	          if (idx + 1 === length) {
	            lastOriginalSource = null;
	            sourceMappingActive = false;
	          } else if (sourceMappingActive) {
	            map.addMapping({
	              source: original.source,
	              original: {
	                line: original.line,
	                column: original.column
	              },
	              generated: {
	                line: generated.line,
	                column: generated.column
	              },
	              name: original.name
	            });
	          }
	        } else {
	          generated.column++;
	        }
	      }
	    });
	    this.walkSourceContents(function(sourceFile, sourceContent) {
	      map.setSourceContent(sourceFile, sourceContent);
	    });

	    return { code: generated.code, map };
	  }
	}

	var SourceNode_1 = SourceNode;

	var sourceNode = {
		SourceNode: SourceNode_1
	};

	/*
	 * Copyright 2009-2011 Mozilla Foundation and contributors
	 * Licensed under the New BSD license. See LICENSE.txt or:
	 * http://opensource.org/licenses/BSD-3-Clause
	 */
	var SourceMapGenerator$2 = sourceMapGenerator.SourceMapGenerator;
	var SourceMapConsumer$1 = sourceMapConsumer.SourceMapConsumer;
	var SourceNode$1 = sourceNode.SourceNode;

	var sourceMap = {
		SourceMapGenerator: SourceMapGenerator$2,
		SourceMapConsumer: SourceMapConsumer$1,
		SourceNode: SourceNode$1
	};

	var Compiler_1 = createCommonjsModule(function (module, exports) {
	Object.defineProperty(exports, "__esModule", { value: true });
	var Compiler = /** @class */ (function () {
	    function Compiler(rules) {
	        this.rules = rules;
	        this.fragmentsBefore = [];
	        this.fragmentsAfter = [];
	    }
	    Compiler.prototype.use = function (rule) {
	        if (rule.name in this.rules) {
	            throw new Error("A rule with this name already exists: " + rule.name);
	        }
	        this.rules[rule.name] = rule;
	    };
	    Compiler.prototype.addFragment = function (position, f) {
	        if (position === "after") {
	            this.fragmentsAfter.splice(0, 0, f);
	        }
	        else {
	            this.fragmentsBefore.push(f);
	        }
	    };
	    Compiler.prototype.compile = function (input, options) {
	        try {
	            var tokenizer = new Tokenizer_1.default(options.file);
	            tokenizer.consume(input);
	            var tokens = tokenizer.close();
	            return this.processTokens(tokens, options);
	        }
	        catch (e) {
	            if (e.name === "CompileError") {
	                var file = 'anonymous';
	                if (options && options.file != null) {
	                    file = options.file;
	                }
	                console.error(this.prettyPrintError(e, input, file));
	            }
	            throw e;
	        }
	    };
	    Compiler.prototype.processTokens = function (tokens, options) {
	        var _this = this;
	        var context = new CompilerInterface.Context();
	        for (var _i = 0, _a = Object.keys(this.rules); _i < _a.length; _i++) {
	            var i = _a[_i];
	            var rule = this.rules[i];
	            if (rule.initContext) {
	                rule.initContext(context);
	            }
	        }
	        var fragments = tokens.reduce(function (acc, t) {
	            var rule = _this.getRule(t);
	            return acc.concat(rule.analyze(context, t));
	        }, []);
	        var dummyPosition = {
	            line: 1, ch: 0, file: options.file
	        };
	        var before = this.fragmentsBefore.map(function (f) { return new f(dummyPosition); });
	        var after = this.fragmentsAfter.map(function (f) { return new f(dummyPosition); });
	        var root = new sourceMap.SourceNode(0, 0, 'TODO', before.concat(fragments, after).map(function (f) {
	            return new sourceMap.SourceNode(f.line, f.ch, f.file || '', f.render(context));
	        }));
	        return root.toStringWithSourceMap();
	    };
	    Compiler.prototype.prettyPrintError = function (e, text, file) {
	        var i = 0;
	        for (var line = 1; line < e.line && i < text.length; i++, line += text.charAt(i) === "\n" ? 1 : 0)
	            ;
	        var pretty = text.substr(i + 1);
	        var nextNL = pretty.indexOf("\n");
	        if (nextNL !== -1) {
	            pretty = pretty.substr(0, nextNL);
	        }
	        var spacer = Array(e.ch).join(" ");
	        pretty += "\n" + spacer + "^";
	        pretty += "\n" + e;
	        return "\n" + pretty + "\n    at " + file + ":" + e.line + ":" + e.ch + "\n";
	    };
	    Compiler.prototype.getRule = function (t) {
	        if (t.type === Token_1.TextToken.type) {
	            return this.rules._text;
	        }
	        else if (t.type === Token_1.AtRuleToken.type) {
	            if (t.ruleName === "") {
	                return this.rules._default;
	            }
	            else if (t.ruleName in this.rules) {
	                return this.rules[t.ruleName];
	            }
	            else {
	                throw new CompileError_1.default("Unknown rule: \"" + t.ruleName + "\"", t.line, t.ch);
	            }
	        }
	        throw new CompileError_1.default("Unrecognized token type: " + t.type, t.line, t.ch);
	    };
	    return Compiler;
	}());
	exports.default = Compiler;

	});

	unwrapExports(Compiler_1);

	var wrapper = createCommonjsModule(function (module, exports) {
	var __extends = (commonjsGlobal && commonjsGlobal.__extends) || (function () {
	    var extendStatics = function (d, b) {
	        extendStatics = Object.setPrototypeOf ||
	            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
	            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
	        return extendStatics(d, b);
	    };
	    return function (d, b) {
	        extendStatics(d, b);
	        function __() { this.constructor = d; }
	        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	    };
	})();
	Object.defineProperty(exports, "__esModule", { value: true });

	var WrapperBeforeFragment = /** @class */ (function (_super) {
	    __extends(WrapperBeforeFragment, _super);
	    function WrapperBeforeFragment() {
	        return _super !== null && _super.apply(this, arguments) || this;
	    }
	    WrapperBeforeFragment.prototype.render = function (ctx) {
	        var paramsTypeDecl = "export type __Params = {\n" + ctx.params.map(function (p) { return '            ' + p.name + ': ' + p.type; }).join(',\n') + "\n} " + (ctx.extends.parentTemplate ? '& __ParentParams' : '');
	        var argParams = "__params" + (ctx.params.length === 0 ? '?' : '') + ": __Params";
	        var sectionsType = "{\n" + ctx.sections.names.map(function (n) { return "            '" + n + "'?: __Section;"; }).join('\n') + "\n        }";
	        var safeSectionsType = "{\n" + ctx.sections.names.map(function (n) { return "            '" + n + "': __Section;"; }).join('\n') + "\n        }";
	        var argSections = "__childSections?: " + sectionsType;
	        var paramsDereference = ctx.params.map(function (p) { return "    const " + p.name + " = __params." + p.name + ";"; }).join('\n');
	        var imports = ctx.imports.map(function (i) {
	            return 'import ' + i + ';';
	        })
	            .join('\n');
	        // We need to use the parent's definition of a Section otherwis the typescript compiler chokes (as of tsc@2.4.1)
	        var parentImport = ctx.extends.parentTemplate ?
	            "import __parent, { __Params as __ParentParams } from " + ctx.extends.parentTemplate :
	            '';
	        var sectionsExpr = "\n    let __safeChildSections: " + sectionsType + " = __childSections || {};\n    __safeChildSections;\n    const __sections: " + safeSectionsType + " = {\n" + ctx.sections.names.map(function (n) { return "        \"" + n + "\": __safeSection(__safeChildSections[\"" + n + "\"])"; }).join(',\n') + "\n    };\n    __sections;";
	        var sectionInterfaceDecl = "export interface __Section {\n    (parent: () => string): () => string;\n}";
	        return ("\n/* tslint:disable */\n// This file was generated from a topside template.\n// Do not edit this file, edit the original template instead.\n\nimport * as __escape from 'escape-html';\n__escape;\n" + imports + "\n" + parentImport + "\n" + sectionInterfaceDecl + "\n" + paramsTypeDecl + "\n\nfunction __identity<T>(t: T): T {\n    return t;\n}\n__identity;\n\nfunction __safeSection(section?: __Section): __Section {\n        return section ? section : __identity;\n}\n__safeSection;\n\nexport default function(" + argParams + ", " + argSections + "): string {\n" + paramsDereference + "\n" + sectionsExpr + "\n    const __text = \"");
	    };
	    return WrapperBeforeFragment;
	}(CompilerInterface.Fragment));
	exports.WrapperBeforeFragment = WrapperBeforeFragment;
	var WrapperAfterFragment = /** @class */ (function (_super) {
	    __extends(WrapperAfterFragment, _super);
	    function WrapperAfterFragment() {
	        return _super !== null && _super.apply(this, arguments) || this;
	    }
	    WrapperAfterFragment.prototype.render = function (ctx) {
	        return "\";\n    __text;\n    return " + (ctx.extends.parentTemplate ? '__parent(__params, __sections)' : '__text') + ";\n};";
	    };
	    return WrapperAfterFragment;
	}(CompilerInterface.Fragment));
	exports.WrapperAfterFragment = WrapperAfterFragment;

	});

	unwrapExports(wrapper);
	var wrapper_1 = wrapper.WrapperBeforeFragment;
	var wrapper_2 = wrapper.WrapperAfterFragment;

	var conditionals = createCommonjsModule(function (module, exports) {
	var __extends = (commonjsGlobal && commonjsGlobal.__extends) || (function () {
	    var extendStatics = function (d, b) {
	        extendStatics = Object.setPrototypeOf ||
	            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
	            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
	        return extendStatics(d, b);
	    };
	    return function (d, b) {
	        extendStatics(d, b);
	        function __() { this.constructor = d; }
	        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	    };
	})();
	Object.defineProperty(exports, "__esModule", { value: true });

	var IfFragment = /** @class */ (function (_super) {
	    __extends(IfFragment, _super);
	    function IfFragment(position, expr) {
	        var _this = _super.call(this, position) || this;
	        _this.expr = expr;
	        return _this;
	    }
	    IfFragment.prototype.render = function () {
	        return ('" + \n' +
	            '(function() {\n' +
	            '    if (' +
	            this.expr +
	            ') {\n' +
	            '        return ("');
	    };
	    return IfFragment;
	}(CompilerInterface.Fragment));
	exports.IfFragment = IfFragment;
	var ElseIfFragment = /** @class */ (function (_super) {
	    __extends(ElseIfFragment, _super);
	    function ElseIfFragment(position, expr) {
	        var _this = _super.call(this, position) || this;
	        _this.expr = expr;
	        return _this;
	    }
	    ElseIfFragment.prototype.render = function () {
	        return ('");\n' +
	            '    } else if (' +
	            this.expr +
	            ') {\n' +
	            '        return ("');
	    };
	    return ElseIfFragment;
	}(CompilerInterface.Fragment));
	exports.ElseIfFragment = ElseIfFragment;
	var ElseFragment = /** @class */ (function (_super) {
	    __extends(ElseFragment, _super);
	    function ElseFragment() {
	        return _super !== null && _super.apply(this, arguments) || this;
	    }
	    ElseFragment.prototype.render = function () {
	        return '");\n' + '    } else {\n' + '        return ("';
	    };
	    return ElseFragment;
	}(CompilerInterface.Fragment));
	exports.ElseFragment = ElseFragment;
	var EndIfFragment = /** @class */ (function (_super) {
	    __extends(EndIfFragment, _super);
	    function EndIfFragment(position, includeReturn) {
	        var _this = _super.call(this, position) || this;
	        _this.includeReturn = includeReturn;
	        return _this;
	    }
	    EndIfFragment.prototype.render = function () {
	        return "\");\n    }\n    " + (this.includeReturn ? 'return "";' : '') + "}()) + \"";
	    };
	    return EndIfFragment;
	}(CompilerInterface.Fragment));
	exports.EndIfFragment = EndIfFragment;

	});

	unwrapExports(conditionals);
	var conditionals_1 = conditionals.IfFragment;
	var conditionals_2 = conditionals.ElseIfFragment;
	var conditionals_3 = conditionals.ElseFragment;
	var conditionals_4 = conditionals.EndIfFragment;

	var conditionals$2 = createCommonjsModule(function (module, exports) {
	Object.defineProperty(exports, "__esModule", { value: true });

	exports.IfRule = {
	    name: "if",
	    initContext: function (ctx) {
	        ctx.conditionals = {
	            statementStack: []
	        };
	    },
	    analyze: function (ctx, t) {
	        ctx.conditionals.statementStack.splice(0, 0, {
	            hasElse: false
	        });
	        return new conditionals.IfFragment(t, t.data);
	    }
	};
	exports.ElseRule = {
	    name: "else",
	    analyze: function (ctx, t) {
	        ctx.conditionals.statementStack[0].hasElse = true;
	        return new conditionals.ElseFragment(t);
	    }
	};
	exports.ElseIfRule = {
	    name: "elseif",
	    analyze: function (_, t) {
	        return new conditionals.ElseIfFragment(t, t.data);
	    }
	};
	exports.EndIfRule = {
	    name: "endif",
	    analyze: function (ctx, t) {
	        // Skips the return statement if there is an `else` block to avoid generating unreachable code.
	        var returnStatement = !ctx.conditionals.statementStack[0].hasElse;
	        ctx.conditionals.statementStack.splice(0, 1);
	        return new conditionals.EndIfFragment(t, returnStatement);
	    }
	};

	});

	unwrapExports(conditionals$2);
	var conditionals_2$1 = conditionals$2.IfRule;
	var conditionals_3$1 = conditionals$2.ElseRule;
	var conditionals_4$1 = conditionals$2.ElseIfRule;
	var conditionals_5 = conditionals$2.EndIfRule;

	var _for = createCommonjsModule(function (module, exports) {
	var __extends = (commonjsGlobal && commonjsGlobal.__extends) || (function () {
	    var extendStatics = function (d, b) {
	        extendStatics = Object.setPrototypeOf ||
	            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
	            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
	        return extendStatics(d, b);
	    };
	    return function (d, b) {
	        extendStatics(d, b);
	        function __() { this.constructor = d; }
	        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	    };
	})();
	Object.defineProperty(exports, "__esModule", { value: true });

	var BeginForFragment = /** @class */ (function (_super) {
	    __extends(BeginForFragment, _super);
	    function BeginForFragment(position, expr) {
	        var _this = _super.call(this, position) || this;
	        _this.expr = expr;
	        return _this;
	    }
	    BeginForFragment.prototype.render = function () {
	        return ('" + \n' +
	            '(function() {\n' +
	            '    let __acc = "";\n' +
	            '    for (let ' +
	            this.expr +
	            ') {\n' +
	            '        __acc += ("');
	    };
	    return BeginForFragment;
	}(CompilerInterface.Fragment));
	exports.BeginForFragment = BeginForFragment;
	var EndForFragment = /** @class */ (function (_super) {
	    __extends(EndForFragment, _super);
	    function EndForFragment() {
	        return _super !== null && _super.apply(this, arguments) || this;
	    }
	    EndForFragment.prototype.render = function () {
	        return '");\n' + '    }\n' + '    return __acc;\n' + '}()) + "';
	    };
	    return EndForFragment;
	}(CompilerInterface.Fragment));
	exports.EndForFragment = EndForFragment;

	});

	unwrapExports(_for);
	var _for_1 = _for.BeginForFragment;
	var _for_2 = _for.EndForFragment;

	var _for$2 = createCommonjsModule(function (module, exports) {
	Object.defineProperty(exports, "__esModule", { value: true });

	exports.ForRule = {
	    name: "for",
	    analyze: function (ctx, t) {
	        return new _for.BeginForFragment(t, t.data);
	    }
	};
	exports.EndForRule = {
	    name: "endfor",
	    analyze: function (ctx, t) {
	        return new _for.EndForFragment(t);
	    }
	};

	});

	unwrapExports(_for$2);
	var _for_1$1 = _for$2.ForRule;
	var _for_2$1 = _for$2.EndForRule;

	var html = createCommonjsModule(function (module, exports) {
	var __extends = (commonjsGlobal && commonjsGlobal.__extends) || (function () {
	    var extendStatics = function (d, b) {
	        extendStatics = Object.setPrototypeOf ||
	            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
	            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
	        return extendStatics(d, b);
	    };
	    return function (d, b) {
	        extendStatics(d, b);
	        function __() { this.constructor = d; }
	        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	    };
	})();
	Object.defineProperty(exports, "__esModule", { value: true });

	var HtmlFragment = /** @class */ (function (_super) {
	    __extends(HtmlFragment, _super);
	    function HtmlFragment(position, html) {
	        var _this = _super.call(this, position) || this;
	        _this.html = html;
	        return _this;
	    }
	    HtmlFragment.prototype.render = function () {
	        return '" + (' + this.html + ') + "';
	    };
	    return HtmlFragment;
	}(CompilerInterface.Fragment));
	exports.HtmlFragment = HtmlFragment;

	});

	unwrapExports(html);
	var html_1 = html.HtmlFragment;

	var html$2 = createCommonjsModule(function (module, exports) {
	Object.defineProperty(exports, "__esModule", { value: true });

	exports.HtmlRule = {
	    name: "html",
	    analyze: function (ctx, t) {
	        return new html.HtmlFragment(t, t.data);
	    }
	};

	});

	unwrapExports(html$2);
	var html_2 = html$2.HtmlRule;

	var _null = createCommonjsModule(function (module, exports) {
	var __extends = (commonjsGlobal && commonjsGlobal.__extends) || (function () {
	    var extendStatics = function (d, b) {
	        extendStatics = Object.setPrototypeOf ||
	            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
	            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
	        return extendStatics(d, b);
	    };
	    return function (d, b) {
	        extendStatics(d, b);
	        function __() { this.constructor = d; }
	        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	    };
	})();
	Object.defineProperty(exports, "__esModule", { value: true });

	var NullFragment = /** @class */ (function (_super) {
	    __extends(NullFragment, _super);
	    function NullFragment() {
	        return _super !== null && _super.apply(this, arguments) || this;
	    }
	    NullFragment.prototype.render = function () {
	        return '';
	    };
	    return NullFragment;
	}(CompilerInterface.Fragment));
	exports.default = NullFragment;

	});

	unwrapExports(_null);

	var _import = createCommonjsModule(function (module, exports) {
	Object.defineProperty(exports, "__esModule", { value: true });

	var SEMICOLON_RX = /;$/;
	exports.ImportRule = {
	    name: "import",
	    initContext: function (ctx) {
	        ctx.imports = [];
	    },
	    analyze: function (ctx, t) {
	        var importExpr = t.data.trim().replace(SEMICOLON_RX, "");
	        ctx.imports.push(importExpr);
	        return new _null.default(t);
	    }
	};

	});

	unwrapExports(_import);
	var _import_1 = _import.ImportRule;

	var param = createCommonjsModule(function (module, exports) {
	Object.defineProperty(exports, "__esModule", { value: true });


	var SEMICOLON_RX = /;$/;
	exports.ParamRule = {
	    name: "param",
	    initContext: function (ctx) {
	        ctx.params = [];
	    },
	    analyze: function (ctx, t) {
	        var parts = t.data.split(":");
	        if (parts.length === 1 || parts[1].trim().length === 0) {
	            var errorPos = t.ch + exports.ParamRule.name.length + 2;
	            throw new CompileError_1.default("Missing type annotation.", t.line, errorPos);
	        }
	        if (parts[0].trim().indexOf('__') === 0) {
	            throw new CompileError_1.default("Parameter name cannot start with '__'", t.line, t.ch);
	        }
	        ctx.params.push({
	            name: parts[0].trim(),
	            type: parts[1].trim().replace(SEMICOLON_RX, "")
	        });
	        return new _null.default(t);
	    }
	};

	});

	unwrapExports(param);
	var param_1 = param.ParamRule;

	var passthrough = createCommonjsModule(function (module, exports) {
	var __extends = (commonjsGlobal && commonjsGlobal.__extends) || (function () {
	    var extendStatics = function (d, b) {
	        extendStatics = Object.setPrototypeOf ||
	            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
	            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
	        return extendStatics(d, b);
	    };
	    return function (d, b) {
	        extendStatics(d, b);
	        function __() { this.constructor = d; }
	        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	    };
	})();
	Object.defineProperty(exports, "__esModule", { value: true });

	var PassThroughFragment = /** @class */ (function (_super) {
	    __extends(PassThroughFragment, _super);
	    function PassThroughFragment(position, text) {
	        var _this = _super.call(this, position) || this;
	        _this.text = text;
	        return _this;
	    }
	    PassThroughFragment.prototype.render = function () {
	        return JSON.stringify(this.text).slice(1, -1);
	    };
	    return PassThroughFragment;
	}(CompilerInterface.Fragment));
	exports.PassThroughFragment = PassThroughFragment;

	});

	unwrapExports(passthrough);
	var passthrough_1 = passthrough.PassThroughFragment;

	var passthrough$2 = createCommonjsModule(function (module, exports) {
	Object.defineProperty(exports, "__esModule", { value: true });

	exports.PassThroughRule = {
	    name: "passthrough",
	    analyze: function (ctx, t) {
	        return new passthrough.PassThroughFragment(t, t.data);
	    }
	};

	});

	unwrapExports(passthrough$2);
	var passthrough_2 = passthrough$2.PassThroughRule;

	var text = createCommonjsModule(function (module, exports) {
	var __extends = (commonjsGlobal && commonjsGlobal.__extends) || (function () {
	    var extendStatics = function (d, b) {
	        extendStatics = Object.setPrototypeOf ||
	            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
	            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
	        return extendStatics(d, b);
	    };
	    return function (d, b) {
	        extendStatics(d, b);
	        function __() { this.constructor = d; }
	        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	    };
	})();
	Object.defineProperty(exports, "__esModule", { value: true });

	var TextFragment = /** @class */ (function (_super) {
	    __extends(TextFragment, _super);
	    function TextFragment(position, text) {
	        var _this = _super.call(this, position) || this;
	        _this.text = text;
	        return _this;
	    }
	    TextFragment.prototype.render = function () {
	        return '" + __escape("" + (' + this.text + ')) + "';
	    };
	    return TextFragment;
	}(CompilerInterface.Fragment));
	exports.TextFragment = TextFragment;

	});

	unwrapExports(text);
	var text_1 = text.TextFragment;

	var text$2 = createCommonjsModule(function (module, exports) {
	Object.defineProperty(exports, "__esModule", { value: true });

	exports.TextRule = {
	    name: "text",
	    analyze: function (_ctx, t) {
	        return new text.TextFragment(t, t.data);
	    }
	};

	});

	unwrapExports(text$2);
	var text_2 = text$2.TextRule;

	var _extends = createCommonjsModule(function (module, exports) {
	Object.defineProperty(exports, "__esModule", { value: true });


	exports.ExtendsRule = {
	    name: "extends",
	    initContext: function (ctx) {
	        ctx.extends = {
	            parentTemplate: null
	        };
	    },
	    analyze: function (ctx, t) {
	        var data = t.data.trim();
	        if (data.length < 2 || data.charAt(0) !== data.charAt(data.length - 1) || ['"', "'"].indexOf(data.charAt(0)) === -1) {
	            console.error(data);
	            var errorPos = t.ch + exports.ExtendsRule.name.length + 2;
	            throw new CompileError_1.default("Invalid parent template name (be sure to use a quoted string)", t.line, errorPos);
	        }
	        if (ctx.extends.parentTemplate) {
	            throw new CompileError_1.default("Duplicate 'extends' directives", t.line, t.ch + 2);
	        }
	        ctx.extends.parentTemplate = data;
	        return new _null.default(t);
	    }
	};

	});

	unwrapExports(_extends);
	var _extends_1 = _extends.ExtendsRule;

	var comment = createCommonjsModule(function (module, exports) {
	Object.defineProperty(exports, "__esModule", { value: true });

	exports.CommentRule = {
	    name: "--",
	    analyze: function (ctx, t) {
	        return new _null.default(t);
	    }
	};

	});

	unwrapExports(comment);
	var comment_1 = comment.CommentRule;

	var section = createCommonjsModule(function (module, exports) {
	var __extends = (commonjsGlobal && commonjsGlobal.__extends) || (function () {
	    var extendStatics = function (d, b) {
	        extendStatics = Object.setPrototypeOf ||
	            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
	            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
	        return extendStatics(d, b);
	    };
	    return function (d, b) {
	        extendStatics(d, b);
	        function __() { this.constructor = d; }
	        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	    };
	})();
	Object.defineProperty(exports, "__esModule", { value: true });

	var InlineSectionFragment = /** @class */ (function (_super) {
	    __extends(InlineSectionFragment, _super);
	    function InlineSectionFragment(position, name, body) {
	        var _this = _super.call(this, position) || this;
	        _this.name = name;
	        _this.body = body;
	        return _this;
	    }
	    InlineSectionFragment.prototype.render = function () {
	        return "\" + (() => {\n            const __sectionName = \"" + this.name + "\";\n            __sections[__sectionName] = ((__parent: () => string) => __safeSection(__safeChildSections[__sectionName])(\n                () => __escape(" + this.body + ")));\n            return \"\";\n        })() + \"";
	    };
	    return InlineSectionFragment;
	}(CompilerInterface.Fragment));
	exports.InlineSectionFragment = InlineSectionFragment;
	var BeginSectionFragment = /** @class */ (function (_super) {
	    __extends(BeginSectionFragment, _super);
	    function BeginSectionFragment(position, name) {
	        var _this = _super.call(this, position) || this;
	        _this.name = name;
	        return _this;
	    }
	    BeginSectionFragment.prototype.render = function () {
	        return "\" + (() => {\n            const __sectionName = \"" + this.name + "\";\n            __sections[__sectionName] = ((__parent: () => string) => __safeSection(__safeChildSections[__sectionName])(() => \"";
	    };
	    return BeginSectionFragment;
	}(CompilerInterface.Fragment));
	exports.BeginSectionFragment = BeginSectionFragment;
	var EndSectionFragment = /** @class */ (function (_super) {
	    __extends(EndSectionFragment, _super);
	    function EndSectionFragment() {
	        return _super !== null && _super.apply(this, arguments) || this;
	    }
	    EndSectionFragment.prototype.render = function () {
	        return "\"));\n            return \"\";\n        })() + \"";
	    };
	    return EndSectionFragment;
	}(CompilerInterface.Fragment));
	exports.EndSectionFragment = EndSectionFragment;
	var ParentFragment = /** @class */ (function (_super) {
	    __extends(ParentFragment, _super);
	    function ParentFragment() {
	        return _super !== null && _super.apply(this, arguments) || this;
	    }
	    ParentFragment.prototype.render = function () {
	        return "\" + __parent() + \"";
	    };
	    return ParentFragment;
	}(CompilerInterface.Fragment));
	exports.ParentFragment = ParentFragment;
	var YieldFragment = /** @class */ (function (_super) {
	    __extends(YieldFragment, _super);
	    function YieldFragment(position, name) {
	        var _this = _super.call(this, position) || this;
	        _this.name = name;
	        return _this;
	    }
	    YieldFragment.prototype.render = function () {
	        return "\" + __sections[\"" + this.name + "\"](() => \"\")() + \"";
	    };
	    return YieldFragment;
	}(CompilerInterface.Fragment));
	exports.YieldFragment = YieldFragment;
	var ShowFragment = /** @class */ (function (_super) {
	    __extends(ShowFragment, _super);
	    function ShowFragment() {
	        return _super !== null && _super.apply(this, arguments) || this;
	    }
	    ShowFragment.prototype.render = function () {
	        return "\"));\n            return __sections[__sectionName](() => \"\")();\n        })() + \"";
	    };
	    return ShowFragment;
	}(CompilerInterface.Fragment));
	exports.ShowFragment = ShowFragment;

	});

	unwrapExports(section);
	var section_1 = section.InlineSectionFragment;
	var section_2 = section.BeginSectionFragment;
	var section_3 = section.EndSectionFragment;
	var section_4 = section.ParentFragment;
	var section_5 = section.YieldFragment;
	var section_6 = section.ShowFragment;

	var section$2 = createCommonjsModule(function (module, exports) {
	Object.defineProperty(exports, "__esModule", { value: true });

	function cleanQuotes(str) {
	    str = str.trim();
	    var q = str.charAt(0);
	    if (q === "'" || q === '"') {
	        if (str.charAt(str.length - 1) === q) {
	            return str.substr(1, str.length - 2);
	        }
	        else {
	            throw new Error("Invalid string literal: " + str);
	        }
	    }
	    return str;
	}
	/**
	 * Extracts the section name from the tag.
	 *
	 * In case the string is quoted, quotes are removed (to support usage à la blade).
	 *
	 * For simplicity, this just looks if there's a comma and uses everything before.
	 * It is pretty intuitive when the at-rule is used without quotes as recommended
	 * in the doc but counter-intuitively fails to parse @section('aa,bb');
	 *
	 * @param str The input string as seen in the source
	 */
	function getCleanSectionName(str) {
	    return cleanQuotes(str.split(',')[0]);
	}
	/**
	 * Extracts the section data from the tag.
	 *
	 * Users can use the shorthand
	 *
	 *     @section(name, data)
	 *
	 * Which stands for
	 *
	 *     @section(name)@(data)@endsection
	 *
	 * @param str The input string as seen in the source
	 */
	function getCleanSectionData(str) {
	    var commaIdx = str.indexOf(',');
	    if (commaIdx === -1) {
	        return null;
	    }
	    else {
	        return str.substr(commaIdx + 1).trim();
	    }
	}
	exports.SectionRule = {
	    name: "section",
	    initContext: function (ctx) {
	        ctx.sections = {
	            names: []
	        };
	    },
	    analyze: function (ctx, t) {
	        // TODO: support the form @section('name', 'data')
	        var name = getCleanSectionName(t.data);
	        if (ctx.sections.names.indexOf(name) === -1) {
	            ctx.sections.names.push(name);
	        }
	        var data = getCleanSectionData(t.data);
	        if (data != null) {
	            return new section.InlineSectionFragment(t, name, data);
	        }
	        else {
	            return new section.BeginSectionFragment(t, name);
	        }
	    }
	};
	exports.EndSectionRule = {
	    name: "endsection",
	    analyze: function (_ctx, t) {
	        return new section.EndSectionFragment(t);
	    }
	};
	exports.ParentRule = {
	    name: "parent",
	    analyze: function (_ctx, t) {
	        return new section.ParentFragment(t);
	    }
	};
	exports.YieldRule = {
	    name: "yield",
	    analyze: function (ctx, t) {
	        var name = cleanQuotes(t.data);
	        if (ctx.sections.names.indexOf(name) === -1) {
	            ctx.sections.names.push(name);
	        }
	        return new section.YieldFragment(t, name);
	    }
	};
	exports.ShowRule = {
	    name: "show",
	    analyze: function (_ctx, t) {
	        return new section.ShowFragment(t);
	    }
	};

	});

	unwrapExports(section$2);
	var section_2$1 = section$2.SectionRule;
	var section_3$1 = section$2.EndSectionRule;
	var section_4$1 = section$2.ParentRule;
	var section_5$1 = section$2.YieldRule;
	var section_6$1 = section$2.ShowRule;

	var topside = createCommonjsModule(function (module, exports) {
	// Import here Polyfills if needed. Recommended core-js (npm i -D core-js)
	Object.defineProperty(exports, "__esModule", { value: true });












	/**
	 * Global preconfigured compiler
	 */
	exports.compiler = new Compiler_1.default({
	    _text: passthrough$2.PassThroughRule,
	    _default: text$2.TextRule
	});
	exports.compiler.use(comment.CommentRule);
	exports.compiler.use(conditionals$2.ElseIfRule);
	exports.compiler.use(conditionals$2.ElseRule);
	exports.compiler.use(_for$2.EndForRule);
	exports.compiler.use(conditionals$2.EndIfRule);
	exports.compiler.use(_extends.ExtendsRule);
	exports.compiler.use(_for$2.ForRule);
	exports.compiler.use(html$2.HtmlRule);
	exports.compiler.use(conditionals$2.IfRule);
	exports.compiler.use(_import.ImportRule);
	exports.compiler.use(section$2.ParentRule);
	exports.compiler.use(param.ParamRule);
	exports.compiler.use(passthrough$2.PassThroughRule);
	exports.compiler.use(section$2.SectionRule);
	exports.compiler.use(section$2.ShowRule);
	exports.compiler.use(section$2.EndSectionRule);
	exports.compiler.use(text$2.TextRule);
	exports.compiler.use(section$2.YieldRule);
	exports.compiler.addFragment("before", wrapper.WrapperBeforeFragment);
	exports.compiler.addFragment("after", wrapper.WrapperAfterFragment);

	});

	var topside$1 = unwrapExports(topside);
	var topside_1 = topside.compiler;

	exports.default = topside$1;
	exports.compiler = topside_1;

	Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=topside.umd.js.map
