import { ISourcePosition } from './ISourcePosition';
export declare class Token implements ISourcePosition {
    readonly type: string;
    readonly data: string;
    readonly line: number;
    readonly ch: number;
    readonly file: string;
    readonly ruleName: string;
    constructor(type: string, data: string, line: number, ch: number, file: string, ruleName: string);
}
export declare abstract class TokenBuilder {
    readonly line: number;
    readonly ch: number;
    readonly file: string;
    abstract readonly type: string;
    data: string[];
    ruleName: string[];
    constructor(line: number, ch: number, file: string);
    build(): Token;
}
export declare class TextToken extends TokenBuilder {
    static type: string;
    readonly type: string;
}
export declare class AtRuleToken extends TokenBuilder {
    static type: string;
    readonly type: string;
}
export declare class InterpolationToken extends TokenBuilder {
    static type: string;
    readonly type: string;
}
