import { Token } from "./Token";
export default class Tokenizer {
    private readonly file;
    private state;
    private it;
    private charStack;
    private hasOpenParen;
    private ended;
    private tokens;
    private currentToken;
    constructor(file: string);
    consume(buf: string): void;
    close(): Token[];
    private assertNotEnded;
    private assertNotEOF;
    private state_text;
    /**
     * @@
     *  ^
     * Here
     */
    private state_atChar;
    /**
     * @rule   (some data)
     * ^
     * Here
     */
    private state_atRuleBegin;
    /**
     * @rule   (some data)
     *  ^^^^
     *  Here
     */
    private state_atRuleName;
    /**
     * @rule   (some data)
     *      ^^^
     *     Here
     */
    private state_atRuleAwaitData;
    /**
     * @rule   (some() data)
     *         ^
     *        Here
     */
    private state_atRuleOpenParen;
    /**
     * @rule   (some data)
     *          ^^^^^^^^^
     *             Here
     */
    private state_atRuleData;
    /**
     * @rule   (some data)
     *                   ^
     *                 Here
     *
     * @simplerule
     *            ^
     *         or here
     */
    private state_atRuleEnd;
    private flushToken;
}
